----------------------------------
--      Locals                  --
----------------------------------
local name = "Timers: Molten Core"
local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..name)

local packNumber = nil

local deathThrottle = nil

----------------------------------
--      Localization            --
----------------------------------
L:RegisterTranslations("enUS", function() return {
	cmd = "TimersMC",
	Bars_cmd = "bars",
	Bars_name= "Bars",
	Bars_desc= "Toggles showing bars for respawn times.",
	Messages_cmd ="messages",
	Messages_name = "Messages",
	Messages_desc = "Toggles showing messages for respawn times.",
	Firelords_cmd = "firelords",
	Firelords_name = "Firelords",
	Firelords_desc = "Toggle spawn timers for Firelord kills.",
	Annihilators_cmd = "annihilator",
	Annihilators_name = "Annihilators",
	Annihilators_desc = "Toggle spawn timers for Annihilator kills.",
	
	

	["%s %d respawns in %d sec"] = true,
	["%s %d respawned!"] = true,
	["Respawn: %s %d"] = true,

	-- Molten Core Triggers
	["Molten Giant"] = true,
	["Ancient Core Hound"] = true,
	["Lava Annihilator"] = true,
	["Lava Surger"] = true,
	["Firelord"] = true,
	["Firewalker"] = true, -- Lava Pack
	["%s collapses and begins to smolder."] = true, -- Hound Pack, emote.
	-- Molten Core Messages
	["Corehound"] = true,
	["Annihilator"] = true,
	["Surger"] = true,
	-- Firelord == Firelord.
	["Core Hound"] = true,
	["Lavapack"] = true,
	["Houndpack"] = true,

} end )
L:RegisterTranslations("deDE", function() return {
	cmd = "TimersMC",
	Bars_cmd = "bars",
	Bars_name= "Balken",
	Bars_desc= "Zeige Balken",
	Messages_cmd ="messages",
	Messages_name = "Warnungen",
	Messages_desc = "Sende Warnungen",
	Firelords_cmd = "firelords",                   --Need trans's
	Firelords_name = "Firelords",
	Firelords_desc = "Toggle spawn timers for Firelord kills.",
	Annihilators_cmd = "annihilator",
	Annihilators_name = "Annihilators",
	Annihilators_desc = "Toggle spawn timers for Annihilator kills.",
	
	
	["%s %d respawns in %d sec"] = "%s %d respawnt in %d Sekunden",
	["%s %d respawned!"] = "%s %s respawnt",
	["Respawn: %s %d"] = "Respawn: %s %d",

	-- Molten Core Triggers
	["Molten Giant"] = "Molten Giant", -- Need translated
	["Ancient Core Hound"] = "Uralter Kernhund",
	["Lava Annihilator"] = "Lavavernichter",
	["Lava Surger"] = "Lavawoger",
	["Firelord"] = "Feuerlord",
	["Firewalker"] = "Feuerg\195\164nger", -- Lava Pack
	["%s collapses and begins to smolder."] = "%s bricht zusammen und beginnt zu glimmen.", -- Hound Pack, emote.
	-- Molten Core Messages
	["Corehound"] =  "Kernhund",
	["Annihilator"] = "Vernichter",
	["Surger"] = "Woger",
	-- Firelord == Firelord.
	["Core Hound"] = "Core Hound", -- need trans
	["Lavapack"] = "Lavapack",
	["Houndpack"] = "Kernhundpack",


} end )

local deathTable = {
	-- MC
	[L["Ancient Core Hound"]] = {1080, L["Corehound"], nil},
	[L["Lava Surger"]]        = {1620, L["Surger"], nil},
	[L["Lava Annihilator"]]   = {7200, L["Annihilator"], nil},
	[L["Firelord"]]           = {7200, L["Firelord"], nil},
	[L["Firewalker"]]         = {7200, L["Lavapack"], nil},
}

local emoteTable = {
	-- MC
	[L["%s collapses and begins to smolder."]] = {3600, L["Houndpack"], nil},
}
local magdown = 0
local garrdown = 0
----------------------------------
--  Addon Declaration           --
----------------------------------

BigWigsMCTimers = BigWigs:NewModule(name)
BigWigsMCTimers.synctoken = name
BigWigsMCTimers.zonename = AceLibrary("Babble-Zone-2.2")["Molten Core"]
BigWigsMCTimers.enabletrigger = { L["Molten Giant"], L["Firelord"], L["Lava Annihilator"], L["Ancient Core Hound"], L["Core Hound"], L["Firewalker"], L["Lava Surger"]}
BigWigsMCTimers.toggleoptions = { "Bars","Messages", "Firelords","Annihilators" }
BigWigsMCTimers.revision = tonumber(string.sub("$Revision: 19666 $", 12, -3))
local garr = AceLibrary("Babble-Boss-2.2")["Garr"]
local mag = AceLibrary("Babble-Boss-2.2")["Magmadar"]
----------------------------------
--      Initialization          --
----------------------------------

function BigWigsMCTimers:OnEnable()
	packNumber = {}
	deathThrottle = {}
	self:RegisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH")
	self:RegisterEvent("CHAT_MSG_MONSTER_EMOTE")
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	
end

----------------------------------
--      Events                  --
----------------------------------
-- Timer hooks for Garr might not work quite right yet, haven't had a chance to test since MC is dead for us atm
function BigWigsMCTimers:CHAT_MSG_COMBAT_HOSTILE_DEATH(msg)
	for key, table in pairs(deathTable) do
		if msg == string.format(UNITDIESOTHER, key) then
			if msg == string.format(UNITDIESOTHER,L["Ancient Core Hound"]) and magdown == 1 then
--			self:TriggerEvent("BigWigs_StartBar", self, "Magmadar2 Down",30)
			break
			end
			if msg == string.format(UNITDIESOTHER,L["Lava Surger"]) and garrdown == 1 then
--			self:TriggerEvent("BigWigs_StartBar", self, "Garr2 Down",30)
			break
			end
			if msg == string.format(UNITDIESOTHER,L["Firelord"]) and not self.db.profile.Firelords then
			break
			end
			if msg == string.format(UNITDIESOTHER,L["Lava Annihilator"]) and not self.db.profile.Annihilators then
			break
			end
			if msg == string.format(UNITDIESOTHER,L["Firewalker"]) and garrdown == 0 and magdown == 0 then
--			self:TriggerEvent("BigWigs_StartBar", self, "BlahBlahVlah",60)
			magdown = 1
			garrdown = 1
				for n = 1, 10 do
				self:TriggerEvent("BigWigs_StopBar", self, "Respawn: "..L["Houndpack"].." ".. n)
				self:TriggerEvent("BigWigs_StopBar", self, "Respawn: "..L["Corehound"].." ".. n)
				self:TriggerEvent("BigWigs_StopBar", self, "Respawn: "..L["Surger"].." "..n)
				end
			end
			self:StartRespawnTimer(table[2], table[1], table[3])
			break
			end
	end

if msg == string.format(UNITDIESOTHER, mag) then
magdown = 1
	for n = 1, 10 do
	self:TriggerEvent("BigWigs_StopBar", self, "Respawn: "..L["Houndpack"].." ".. n)
	self:TriggerEvent("BigWigs_StopBar", self, "Respawn: "..L["Corehound"].." ".. n)
	end
self:TriggerEvent("BigWigs_StartBar", self, "Magmadar Down",30)
--self:UnRegisterEvent("CHAT_MSG_MONSTER_EMOTE")
end
	
if msg == string.format(UNITDIESOTHER, garr) then
self:TriggerEvent("BigWigs_StartBar", self, "Garr Down",30)
garrdown = 1
	for n = 1, 10 do
	self:TriggerEvent("BigWigs_StopBar", self, "Respawn: "..L["Surger"].." "..n)
	end
	
end
end


function BigWigsMCTimers:CHAT_MSG_MONSTER_EMOTE(msg)
	for key, table in pairs(emoteTable) do
		if msg == key then
			self:StartRespawnTimer(table[2], table[1], table[3])
			break
		end
	end
end
function BigWigsMCTimers:ZONE_CHANGED_NEW_AREA()
if not UnitIsGhost("player") then
if GetRealZoneText() == AceLibrary("Babble-Zone-2.2")["Molten Core"] then
else
self.core:ToggleModuleActive(self, false)
end
end
end
----------------------------------
--    Utility                   --
----------------------------------

function BigWigsMCTimers:StartRespawnTimer(message, timer, icon, throttle)
	timer = tonumber(timer)
	if timer == nil then return end

	-- Throttle deaths by 60 seconds.
	if deathThrottle[message] and (deathThrottle[message] + 60) > GetTime() then return end
	deathThrottle[message] = GetTime()

	-- Increment the pack counter after all arguments are checked and we're sure
	-- to start a new respawn timer.
	if not packNumber[message] then packNumber[message] = 0 end
	local nextPack = packNumber[message] + 1
	packNumber[message] = nextPack

	-- Make sure the user wants respawn messages.
	if self.db.profile.Messages then
		self:ScheduleEvent("bwrt"..nextPack.."10secwarn", "BigWigs_Message", timer - 10, string.format(L["%s %d respawns in %d sec"], message, nextPack, 10), "Yellow")
		self:ScheduleEvent("bwrt"..nextPack.."respawned", "BigWigs_Message", timer, string.format(L["%s %d respawned!"], message, nextPack), "Orange")
	end

	-- Make sure the user wants respawn timer bars.
	if self.db.profile.Bars then
		-- Default icon.
		if not icon then icon = "Interface\\Icons\\INV_Misc_Head_Dragon_01" end
		local text = string.format(L["Respawn: %s %d"], message, nextPack)
		self:TriggerEvent("BigWigs_StartBar", self, text, timer, icon)
		self:SetCandyBarOnClick("BigWigsBar "..text, function()
			if IsControlKeyDown() then
				self:TriggerEvent("BigWigs_StopBar", self, text)
				self:CancelScheduledEvent("bwrt"..nextPack.."10secwarn")
				self:CancelScheduledEvent("bwrt"..nextPack.."respawned")
			end
		end)
	end
end

