-- Midnight Reveries Naxxramas Boss Mods v7.20 - 05/09/2006
-- Changed Thaddius code.
-- Added shieldwall announcements to Raz and added The Four Horsemen code.
-- Added logic check for Faerlina silencing twice within 30 seconds.

-- Loading Modules

	-- Spider Wing
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_Anub_OnLoad");
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_Faerlina_OnLoad");
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_Maexxna_OnLoad");

	-- Necro Wing
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_Noth_OnLoad");
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_Heigan_OnLoad");
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_Loatheb_OnLoad");

	-- Deathknight Wing
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_Razuvious_OnLoad");
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_Gothik_OnLoad");
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_Horsemen_OnLoad");

	-- Abomination Wing
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_Patchwerk_OnLoad");
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_Grobbulus_OnLoad");
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_Gluth_OnLoad");
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_Thaddius_OnLoad");

-- Spider Wing

-- Anub'Rekhan (23/08/2006) - Changed timers.
function CT_RABoss_Anub_OnLoad()
	CT_RABoss_AddMod("아눕레칸", CT_RABOSS_ANUB_INFO, 1, CT_RABOSS_LOCATIONS_NAXXRAMAS);
	CT_RABoss_AddEvent("아눕레칸", "CHAT_MSG_MONSTER_YELL", CT_RABoss_Anub_EventHandler);
	CT_RABoss_AddEvent("아눕레칸", "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF", CT_RABoss_Anub_EventHandler);
	CT_RABoss_AddEvent("아눕레칸", "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE", CT_RABoss_Anub_EventHandler);
	CT_RABoss_AddEvent("아눕레칸", "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS", CT_RABoss_Anub_EventHandler);

	CT_RABoss_AddDropDownButton("아눕레칸", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
end

function CT_RABoss_Anub_EventHandler(event)
	if ( not CT_RABoss_Mods["아눕레칸"] or not CT_RABoss_Mods["아눕레칸"]["status"] or not CT_RABoss_Mods["아눕레칸"].enabled ) then
		return;
	end

	if ( event == "CHAT_MSG_MONSTER_YELL" ) then
		if ( arg1 == CT_RABOSS_ANUB_YELL1 or arg1 == CT_RABOSS_ANUB_YELL2 or arg1 == CT_RABOSS_ANUB_YELL3 )  then
			CT_RABoss_Announce(CT_RABOSS_ANUB_ENGAGE, CT_RABoss_Mods["아눕레칸"]["announce"]);
			CT_RABoss_PlaySound(3);
			CT_RABoss_Schedule("CT_RABoss_Anub_EventHandler", 63, "warn30");
			CT_RABoss_Schedule("CT_RABoss_Anub_EventHandler", 83, "warn10");

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["아눕레칸"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_ANUB_LOCUST, "90", "0*255*0"));
			end
		end

	elseif ( event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE" or event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF" ) then
		if ( arg1 == CT_RABOSS_ANUB_CASTSTRING ) then
			CT_RABoss_Announce(CT_RABOSS_ANUB_CASTWARN, CT_RABoss_Mods["아눕레칸"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_UnSchedule("CT_RABoss_Anub_EventHandler");
			CT_RABoss_Schedule("CT_RABoss_Anub_EventHandler", 60, "warn30");
			CT_RABoss_Schedule("CT_RABoss_Anub_EventHandler", 80, "warn10");
			CT_RABoss_Schedule("CT_RABoss_Anub_EventHandler", 23, "locuststop");

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["아눕레칸"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_ANUB_LOCUST, "93", "0*255*0"));
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "2", "23", CT_RABOSS_ANUB_CASTING, "23", "255*0*0"));
			end
		end

	elseif ( event == "warn30" ) then
		CT_RABoss_Announce(format(CT_RABOSS_ANUB_WARN, "30"), CT_RABoss_Mods["아눕레칸"]["announce"]);
		CT_RABoss_PlaySound(3);

	elseif ( event == "warn10" ) then
		CT_RABoss_Announce(format(CT_RABOSS_ANUB_WARN, "10"), CT_RABoss_Mods["아눕레칸"]["announce"]);
		CT_RABoss_PlaySound(3);

	elseif ( event == "locuststop" ) then
		CT_RABoss_Announce(CT_RABOSS_ANUB_ENDED, CT_RABoss_Mods["아눕레칸"]["announce"]);
		CT_RABoss_PlaySound(3);
	end
end


-- Grand Widow Faerlina (11/09/2006) - Added logic check for silencing twice within 30 seconds.
function CT_RABoss_Faerlina_OnLoad()
	CT_RABoss_AddMod("귀부인 팰리나", CT_RABOSS_FAERLINA_INFO, 1, CT_RABOSS_LOCATIONS_NAXXRAMAS);
	CT_RABoss_AddEvent("귀부인 팰리나", "CHAT_MSG_MONSTER_YELL", CT_RABoss_Faerlina_EventHandler);
	CT_RABoss_AddEvent("귀부인 팰리나", "CHAT_MSG_SPELL_FRIENDLYPLAYER_BUFF", CT_RABoss_Faerlina_EventHandler);
	CT_RABoss_AddEvent("귀부인 팰리나", "CHAT_MSG_SPELL_PARTY_BUFF", CT_RABoss_Faerlina_EventHandler);
	CT_RABoss_AddEvent("귀부인 팰리나", "CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE", CT_RABoss_Faerlina_EventHandler);

	CT_RABoss_AddDropDownButton("귀부인 팰리나", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
end

function CT_RABoss_Faerlina_EventHandler(event)
	if ( not CT_RABoss_Mods["귀부인 팰리나"] or not CT_RABoss_Mods["귀부인 팰리나"]["status"] or not CT_RABoss_Mods["귀부인 팰리나"].enabled ) then
		return;
	end

	if ( CT_RABoss_Mods["귀부인 팰리나"]["engaged"] and ( not CT_RABoss_Mods["귀부인 팰리나"]["lastaction"] or ( time() - CT_RABoss_Mods["귀부인 팰리나"]["lastaction"] ) > 120 ) ) then
		CT_RABoss_Mods["귀부인 팰리나"]["engaged"] = false;
	end

	if ( event == "CHAT_MSG_MONSTER_YELL" ) then
		if ( arg1 == CT_RABOSS_FAERLINA_YELL1 or arg1 == CT_RABOSS_FAERLINA_YELL2 or arg1 == CT_RABOSS_FAERLINA_YELL3 or arg1 == CT_RABOSS_FAERLINA_YELL4 ) then
			if ( not CT_RABoss_Mods["귀부인 팰리나"]["engaged"] ) then
				CT_RABoss_Announce(CT_RABOSS_FAERLINA_ENGAGE, CT_RABoss_Mods["귀부인 팰리나"]["announce"]);
				CT_RABoss_PlaySound(3);
				CT_RABoss_Schedule("CT_RABoss_Faerlina_EventHandler", 30, "enrage30");
				CT_RABoss_Schedule("CT_RABoss_Faerlina_EventHandler", 45, "enrage15");
				CT_RABoss_Schedule("CT_RABoss_Faerlina_EventHandler", 55, "enrage5");
				CT_RABoss_Mods["귀부인 팰리나"]["engaged"] = true;
				CT_RABoss_Mods["귀부인 팰리나"]["enraged"] = false;
				CT_RABoss_Mods["귀부인 팰리나"]["silenced"] = false;

				if ( CT_RA_Level >= 1 and CT_RABoss_Mods["귀부인 팰리나"]["announce"] ) then
					CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_FAERLINA_ENRAGE, "60", "255*0*0"));
				end
			else
				CT_RABoss_Announce(CT_RABOSS_FAERLINA_ENRAGEWARN, CT_RABoss_Mods["귀부인 팰리나"]["announce"]);
				CT_RABoss_PlaySound(1);
				CT_RABoss_UnSchedule("CT_RABoss_Faerlina_EventHandler");
				CT_RABoss_Schedule("CT_RABoss_Faerlina_EventHandler", 30, "enrage30");
				CT_RABoss_Schedule("CT_RABoss_Faerlina_EventHandler", 45, "enrage15");
				CT_RABoss_Schedule("CT_RABoss_Faerlina_EventHandler", 55, "enrage5");
				CT_RABoss_Mods["귀부인 팰리나"]["enraged"] = true;
				CT_RABoss_Mods["귀부인 팰리나"]["silenced"] = false;
				CT_RABoss_Mods["귀부인 팰리나"]["enragetimer"] = time();

				if ( CT_RA_Level >= 1 and CT_RABoss_Mods["귀부인 팰리나"]["announce"] ) then
					CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_FAERLINA_ENRAGE, "60", "255*0*0"));
				end
			end
			CT_RABoss_Mods["귀부인 팰리나"]["lastaction"] = time();

		elseif ( arg1 == "CT_RABOSS_FAERLINA_DEAD" ) then
			CT_RABoss_UnSchedule("CT_RABoss_Faerlina_EventHandler");
		end	

	elseif ( event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE" ) then
		if ( arg1 == CT_RABOSS_FAERLINA_EMBRACESTRING ) then
			CT_RABoss_Mods["귀부인 팰리나"]["engaged"] = true;
			CT_RABoss_Mods["귀부인 팰리나"]["lastaction"] = time();

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["귀부인 팰리나"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "2", "30", CT_RABOSS_FAERLINA_SILENCE, "30", "0*255*0"));
			end
		
			if ( CT_RABoss_Mods["귀부인 팰리나"]["enraged"] ) then
				CT_RABoss_Announce(format(CT_RABOSS_FAERLINA_ENRAGESILENCED, (60-(time() - CT_RABoss_Mods["귀부인 팰리나"]["enragetimer"]))), CT_RABoss_Mods["귀부인 팰리나"]["announce"]);
				CT_RABoss_PlaySound(3);
				CT_RABoss_Mods["귀부인 팰리나"]["enraged"] = false;
			else
				CT_RABoss_Announce(CT_RABOSS_FAERLINA_SILENCED, CT_RABoss_Mods["귀부인 팰리나"]["announce"]);
				CT_RABoss_PlaySound(3);	
				if ( ( time() - CT_RABoss_Mods["귀부인 팰리나"]["enragetimer"] ) >= 30 ) then
					CT_RABoss_UnSchedule("CT_RABoss_Faerlina_EventHandler");
					CT_RABoss_Schedule("CT_RABoss_Faerlina_EventHandler", 15, "enrage15");
					CT_RABoss_Schedule("CT_RABoss_Faerlina_EventHandler", 25, "enrage5");

					if ( CT_RA_Level >= 1 and CT_RABoss_Mods["귀부인 팰리나"]["announce"] ) then
						CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "30", CT_RABOSS_FAERLINA_ENRAGE, "30", "255*0*0"));
					end
				end
			end
		end

	elseif ( event == "enrage30") then
		CT_RABoss_Announce(format(CT_RABOSS_FAERLINA_ENRAGEIN, "30"), CT_RABoss_Mods["귀부인 팰리나"]["announce"]);
		CT_RABoss_PlaySound(3);

	elseif ( event == "enrage15") then
		CT_RABoss_Announce(format(CT_RABOSS_FAERLINA_ENRAGEIN, "15"), CT_RABoss_Mods["귀부인 팰리나"]["announce"]);
		CT_RABoss_PlaySound(3);

	elseif ( event == "enrage5") then
		CT_RABoss_Announce(format(CT_RABOSS_FAERLINA_ENRAGEIN, "5"), CT_RABoss_Mods["귀부인 팰리나"]["announce"]);
		CT_RABoss_PlaySound(3);
	end
end


-- Maexxna (19/08/2006) - Changed naming.
function CT_RABoss_Maexxna_OnLoad()
	CT_RABoss_AddMod("맥스나", CT_RABOSS_MAEXXNA_INFO, 1, CT_RABOSS_LOCATIONS_NAXXRAMAS);
	CT_RABoss_AddEvent("맥스나", "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE", CT_RABoss_Maexxna_EventHandler);
	CT_RABoss_AddEvent("맥스나", "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE", CT_RABoss_Maexxna_EventHandler);
	CT_RABoss_AddEvent("맥스나", "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE", CT_RABoss_Maexxna_EventHandler);
	CT_RABoss_AddEvent("맥스나", "CHAT_MSG_MONSTER_EMOTE", CT_RABoss_Maexxna_EventHandler);
	CT_RABoss_AddEvent("맥스나", "CHAT_MSG_ADDON", CT_RABoss_Maexxna_EventHandler);
	CT_RABoss_AddEvent("맥스나", "PLAYER_REGEN_DISABLED", CT_RABoss_Maexxna_EventHandler);

	CT_RABoss_AddDropDownButton("맥스나", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
	CT_RABoss_AddDropDownButton("맥스나", { CT_RABOSS_MAEXXNA_WRAP_ALERT, CT_RABOSS_MAEXXNA_WRAP_ALERT_INFO }, "CT_RABoss_ModInfo", "wrapenable", "CT_RABoss_SetInfo");
	CT_RABoss_AddDropDownButton("맥스나", { CT_RABOSS_MAEXXNA_WRAP_NAMES, CT_RABOSS_MAEXXNA_WRAP_NAMES_INFO }, "CT_RABoss_ModInfo", "wrapnames", "CT_RABoss_Maexxna_Togglenames");


	CT_RABoss_SetVar("맥스나", "wrapenable", 1);
end
	
function CT_RABoss_Maexxna_Togglewraps()
	if ( CT_RABoss_Mods["맥스나"]["wrapenable"] ) then
		CT_RABoss_SetVar("맥스나", "wrapenable", false);
		CT_RABoss_SetVar("맥스나", "wrapnames", false);
		CloseMenus();
	else
		CT_RABoss_SetVar("맥스나", "wrapenable", true);
	end
end
	
function CT_RABoss_Maexxna_Togglenames()
	if ( CT_RABoss_Mods["맥스나"]["wrapnames"] ) then
		CT_RABoss_SetVar("맥스나", "wrapnames", false);
	else
		CT_RABoss_SetVar("맥스나", "wrapnames", true);
		CT_RABoss_SetVar("맥스나", "wrapenable", true);
		CloseMenus();
	end
end

function CT_RABoss_Maexxna_Start()
	CT_RABoss_Announce(CT_RABOSS_MAEXXNA_ENGAGE, CT_RABoss_Mods["맥스나"]["announce"]);
	CT_RABoss_PlaySound(3);	
	CT_RABoss_Mods["맥스나"]["lastaction"] = time();
	CT_RABoss_Mods["맥스나"]["engaged"] = true;
	CT_RABoss_Schedule("CT_RABoss_Maexxna_EventHandler", 20, "webwarn15");
	CT_RABoss_Schedule("CT_RABoss_Maexxna_EventHandler", 25, "webwarn10");
	CT_RABoss_Schedule("CT_RABoss_Maexxna_EventHandler", 30, "webwarn5");

	if ( CT_RA_Level >= 1 and CT_RABoss_Mods["맥스나"]["announce"] ) then
		CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_MAEXXNA_SPRAY, "35", "255*0*0"));
		CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "2", "20", CT_RABOSS_MAEXXNA_SPAWNS, "25", "0*0*255"));
		CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "3", "20", CT_RABOSS_MAEXXNA_WRAPS, "15", "0*255*255"));
	end
end

function CT_RABoss_Maexxna_EventHandler(event)
	if ( not CT_RABoss_Mods["맥스나"] or not CT_RABoss_Mods["맥스나"]["status"] or not CT_RABoss_Mods["맥스나"].enabled ) then
		return;
	end

	if ( CT_RABoss_Mods["맥스나"]["engaged"] and ( not CT_RABoss_Mods["맥스나"]["lastaction"] or ( time() - CT_RABoss_Mods["맥스나"]["lastaction"] ) > 60 ) ) then
		CT_RABoss_Mods["맥스나"]["engaged"] = false;
	end

	if ( event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE" or event == "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE" or event == "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE" ) then
		if ( string.find(arg1, CT_RABOSS_MAEXXNA_SPRAYSTRING) and not CT_RABoss_Mods["맥스나"]["webtrip"] ) then
			CT_RABoss_Announce(CT_RABOSS_MAEXXNA_SPRAYWARN, CT_RABoss_Mods["맥스나"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_Mods["맥스나"]["lastaction"] = time();
			CT_RABoss_Mods["맥스나"]["webtrip"] = true;
			CT_RABoss_UnSchedule("CT_RABoss_Maexxna_EventHandler");
			CT_RABoss_Schedule("CT_RABoss_Maexxna_EventHandler", 25, "webwarn15");
			CT_RABoss_Schedule("CT_RABoss_Maexxna_EventHandler", 30, "webwarn10");
			CT_RABoss_Schedule("CT_RABoss_Maexxna_EventHandler", 35, "webwarn5");

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["맥스나"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_MAEXXNA_SPRAY, "40", "255*0*0"));
			end

		elseif ( CT_RABoss_Mods["맥스나"]["wrapenable"] ) then
			local playername;
			if ( string.find(arg1, "(.+) 감싸기에 걸렸습니다.") ) then
				if ( string.find(arg1, "(.+)%|1이;가; 거미줄") ) then
					local _, _, playername2, playertype = string.find(arg1, CT_RABOSS_MAEXXNA_WWEXP);
					playername = playername2;
					if ( CT_RABoss_Mods["맥스나"]["wrapnames"] ) then
						CT_RABoss_Announce(format(CT_RABOSS_MAEXXNA_WRAPPED, playername));
					end
				elseif ( arg1 == CT_RABOSS_MAEXXNA_TYPE_YOU ) then
					playername = UnitName("player");
					CT_RABoss_Announce(CT_RABOSS_MAEXXNA_WRAPPED_YOU);
					CT_RABoss_PlaySound(2);
				end
			end
			if ( playername ) then
				if ( CT_RA_Level >= 1 and CT_RABoss_Mods["맥스나"]["announce"] ) then
					if ( CT_RABoss_Mods["맥스나"]["wrapnames"] ) then
						CT_RA_AddMessage("MS " .. format(CT_RABOSS_MAEXXNA_WRAPPED, playername));

					elseif ( not CT_RABoss_Mods["맥스나"]["wraptrip"] ) then
						CT_RABoss_Announce(CT_RABOSS_MRMAEXXNA_WRAPWARN, CT_RABoss_Mods["맥스나"]["announce"]);
					end

					if ( not CT_RABoss_Mods["맥스나"]["wraptrip"] ) then
						CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "3", "20", CT_RABOSS_MAEXXNA_WRAPS, "40", "0*255*155"));
						CT_RABoss_PlaySound(2);
					end
				end

				CT_RABoss_Mods["맥스나"]["wraptrip"] = true;
				CT_RABoss_Mods["맥스나"]["lastaction"] = time();
			end
		end

	elseif ( event == "CHAT_MSG_MONSTER_EMOTE" and arg2 == CT_RABOSS_MAEXXNA_BOSSNAME ) then
		if ( arg1 == CT_RABOSS_MAEXXNA_ENRAGESTRING ) then
			CT_RABoss_Announce(CT_RABOSS_MAEXXNA_ENRAGEWARN, CT_RABoss_Mods["맥스나"]["announce"]);
			CT_RABoss_PlaySound(1);	
			CT_RABoss_Mods["맥스나"]["lastaction"] = time();
		end	

	elseif ( event == "PLAYER_REGEN_DISABLED" and not CT_RABoss_Mods["맥스나"]["engaged"] ) then
		CT_RABoss_Schedule("CT_RABoss_Maexxna_EventHandler", 5, "engagecheck");	

	elseif ( event == "CHAT_MSG_ADDON" and arg1 == "CTRA" ) then
		if ( arg2 == "MAEXXNAENGSYNC" and not CT_RABoss_Mods["맥스나"]["engaged"] ) then
			CT_RABoss_Maexxna_Start();
		end

	elseif ( event == "engagecheck" and not CT_RABoss_Mods["맥스나"]["engaged"] ) then
		if ( UnitName("target") == CT_RABOSS_MAEXXNA_BOSSNAME and UnitAffectingCombat("target") ) then
			CT_RABoss_Maexxna_Start();
			CT_RA_SendMessage("MAEXXNAENGSYNC");

		elseif ( UnitName("playertarget") == CT_RABOSS_MAEXXNA_BOSSNAME and UnitAffectingCombat("playertarget") ) then
			CT_RABoss_Maexxna_Start();
			CT_RA_SendMessage("MAEXXNAENGSYNC");
		else
			local i
			for i = 1, GetNumRaidMembers(), 1 do
				if ( UnitName("raid"..i.."target") == CT_RABOSS_MAEXXNA_BOSSNAME and UnitAffectingCombat("raid"..i.."target")) then
					CT_RABoss_Maexxna_Start();
					CT_RA_SendMessage("MAEXXNAENGSYNC");
					break;
				end
			end
		end

	elseif ( event == "webwarn15" ) then
		CT_RABoss_Announce(CT_RABOSS_MAEXXNA_15SEC, CT_RABoss_Mods["맥스나"]["announce"]);
		CT_RABoss_PlaySound(3);	
		CT_RABoss_Mods["맥스나"]["webtrip"] = false;
		CT_RABoss_Mods["맥스나"]["wraptrip"] = false;

	elseif ( event == "webwarn10" ) then
		CT_RABoss_Announce(CT_RABOSS_MAEXXNA_10SEC, CT_RABoss_Mods["맥스나"]["announce"]);
		CT_RABoss_PlaySound(2);	

		if ( CT_RA_Level >= 1 and CT_RABoss_Mods["맥스나"]["announce"] ) then
			CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "2", "20", CT_RABOSS_MAEXXNA_SPAWNS, "40", "0*0*255"));
		end

	elseif ( event == "webwarn5" ) then
		CT_RABoss_Announce(CT_RABOSS_MAEXXNA_5SEC, CT_RABoss_Mods["맥스나"]["announce"]);
		CT_RABoss_PlaySound(3);
	end
end


-- Necro Wing

-- Noth The Plaguebringer (16/07/2006) - Changed exit script.
function CT_RABoss_Noth_OnLoad()
	CT_RABoss_AddMod("역병술사 노스", CT_RABOSS_NOTH_INFO, 1, CT_RABOSS_LOCATIONS_NAXXRAMAS);
	CT_RABoss_AddEvent("역병술사 노스", "CHAT_MSG_MONSTER_YELL", CT_RABoss_Noth_EventHandler);
	CT_RABoss_AddEvent("역병술사 노스", "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS", CT_RABoss_Noth_EventHandler);
	CT_RABoss_AddEvent("역병술사 노스", "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE", CT_RABoss_Noth_EventHandler);
	CT_RABoss_AddEvent("역병술사 노스", "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE", CT_RABoss_Noth_EventHandler);
	CT_RABoss_AddEvent("역병술사 노스", "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE", CT_RABoss_Noth_EventHandler);
	CT_RABoss_AddEvent("역병술사 노스", "CHAT_MSG_COMBAT_CREATURE_VS_CREATURE_HITS", CT_RABoss_Noth_EventHandler);
	CT_RABoss_AddEvent("역병술사 노스", "CHAT_MSG_COMBAT_CREATURE_VS_PARTY_HITS", CT_RABoss_Noth_EventHandler);
	CT_RABoss_AddEvent("역병술사 노스", "CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS", CT_RABoss_Noth_EventHandler);

	CT_RABoss_AddDropDownButton("역병술사 노스", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
	CT_RABoss_AddDropDownButton("역병술사 노스", { CT_RABOSS_NOTH_CURSE_ALERT, CT_RABOSS_NOTH_CURSE_ALERT_INFO }, "CT_RABoss_ModInfo", "enablecurse", "CT_RABoss_SetInfo");
	
	CT_RABoss_SetVar("역병술사 노스", "enablecurse", 1);
end

function CT_RABoss_Noth_EventHandler(event)
	if ( not CT_RABoss_Mods["역병술사 노스"] or not CT_RABoss_Mods["역병술사 노스"]["status"] or not CT_RABoss_Mods["역병술사 노스"].enabled ) then
		return;
	end

	if ( event == "CHAT_MSG_MONSTER_YELL" ) then
		if ( arg1 == CT_RABOSS_NOTH_YELL1 or arg1 == CT_RABOSS_NOTH_YELL2 or arg1 == CT_RABOSS_NOTH_YELL3 ) then
			CT_RABoss_Announce(CT_RABOSS_NOTH_ENGAGED, CT_RABoss_Mods["역병술사 노스"]["announce"]);
			CT_RABoss_PlaySound(3);
			CT_RABoss_Mods["역병술사 노스"]["timeonbalcony"] = 70;
			CT_RABoss_Mods["역병술사 노스"]["timeinroom"] = 90;
			CT_RABoss_Schedule("CT_RABoss_Noth_EventHandler", (CT_RABoss_Mods["역병술사 노스"]["timeinroom"]-10), "teleportwarn");
			CT_RABoss_Schedule("CT_RABoss_Noth_EventHandler", (CT_RABoss_Mods["역병술사 노스"]["timeinroom"]), "teleport");
			CT_RABoss_Mods["역병술사 노스"]["lastaction"] = time();

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["역병술사 노스"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_NOTH_TELEPORT, "90", "0*255*0"));
			end
		elseif ( arg1 == CT_RABOSS_NOTH_DEAD ) then
			CT_RABoss_UnSchedule("CT_RABoss_Noth_EventHandler");
		end

	elseif ( event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS" ) then
		if ( arg1 == CT_RABOSS_NOTH_BLINKSTRING ) then
			CT_RABoss_Announce(CT_RABOSS_NOTH_BLINKWARNING, CT_RABoss_Mods["역병술사 노스"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_Schedule("CT_RABoss_Noth_EventHandler", 28, "blinkwarn");
			CT_RABoss_Mods["역병술사 노스"]["lastaction"] = time();

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["역병술사 노스"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "2", "20", CT_RABOSS_NOTH_BLINK, "30", "0*0*255"));
			end
		end

	elseif ( event == "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE" or event == "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE" or event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE" )  then
		if ( string.find(arg1, CT_RABOSS_NOTH_CURSESTRING) ) then
			if ( CT_RABoss_Mods["역병술사 노스"]["enablecurse"] and not CT_RABoss_Mods["역병술사 노스"]["cursetrip"] ) then
				CT_RABoss_Mods["역병술사 노스"]["cursetrip"] = true;
				CT_RABoss_Announce(CT_RABOSS_NOTH_DISPELL, CT_RABoss_Mods["역병술사 노스"]["announce"]);
				CT_RABoss_PlaySound(2);
				CT_RABoss_Schedule("CT_RABoss_Noth_EventHandler", 5, "precurse");
				CT_RABoss_Mods["역병술사 노스"]["lastaction"] = time();
			end
		end

	elseif ( event == "CHAT_MSG_COMBAT_CREATURE_VS_CREATURE_HITS" or event == "CHAT_MSG_COMBAT_CREATURE_VS_PARTY_HITS" or event == "CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS" ) then
		if ( string.find(arg1, CT_RABOSS_NOTH_BOSSNAME) or string.find(arg1, CT_RABOSS_NOTH_WARRIOR) or string.find(arg1, CT_RABOSS_NOTH_CHAMPION) or string.find(arg1, CT_RABOSS_NOTH_GUARDIAN) ) then
			CT_RABoss_Mods["역병술사 노스"]["lastaction"] = time();
		end	

	elseif ( event == "backinroom" ) then
		if ( not CT_RABoss_Mods["역병술사 노스"]["lastaction"] or ( time() - CT_RABoss_Mods["역병술사 노스"]["lastaction"] ) > 30 ) then
			return;
		else
			CT_RABoss_Announce(format(CT_RABOSS_NOTH_BACK, CT_RABoss_Mods["역병술사 노스"]["timeinroom"]), CT_RABoss_Mods["역병술사 노스"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_Schedule("CT_RABoss_Noth_EventHandler", (CT_RABoss_Mods["역병술사 노스"]["timeinroom"]-10), "teleportwarn");
			CT_RABoss_Schedule("CT_RABoss_Noth_EventHandler", (CT_RABoss_Mods["역병술사 노스"]["timeinroom"]), "teleport");

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["역병술사 노스"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_NOTH_TELEPORT, CT_RABoss_Mods["역병술사 노스"]["timeinroom"], "0*255*0"));
			end
		end

	elseif ( event == "teleport" ) then
		CT_RABoss_UnSchedule("CT_RABoss_Noth_EventHandler", "blinkwarn");
		if ( not CT_RABoss_Mods["역병술사 노스"]["lastaction"] or ( time() - CT_RABoss_Mods["역병술사 노스"]["lastaction"] ) > 30 ) then
			return;
		else
			CT_RABoss_Announce(format(CT_RABOSS_NOTH_TELEPORTED, CT_RABoss_Mods["역병술사 노스"]["timeonbalcony"]), CT_RABoss_Mods["역병술사 노스"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_Schedule("CT_RABoss_Noth_EventHandler", (CT_RABoss_Mods["역병술사 노스"]["timeonbalcony"]-10), "nothsoon");
			CT_RABoss_Schedule("CT_RABoss_Noth_EventHandler", CT_RABoss_Mods["역병술사 노스"]["timeonbalcony"], "backinroom");

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["역병술사 노스"]["announce"]) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_NOTH_BALCONY, CT_RABoss_Mods["역병술사 노스"]["timeonbalcony"], "255*0*0"));
			end

			if ( CT_RABoss_Mods["역병술사 노스"]["timeonbalcony"] == 70 ) then
				CT_RABoss_Mods["역병술사 노스"]["timeonbalcony"] = 95;
				CT_RABoss_Mods["역병술사 노스"]["timeinroom"] = 110;
			elseif ( CT_RABoss_Mods["역병술사 노스"]["timeonbalcony"] == 95 ) then
				CT_RABoss_Mods["역병술사 노스"]["timeonbalcony"] = 120;
				CT_RABoss_Mods["역병술사 노스"]["timeinroom"] = 180;
			end
		end

	elseif ( event == "precurse" ) then
		CT_RABoss_Mods["역병술사 노스"]["cursetrip"] = false;

	elseif ( event == "blinkwarn" ) then
		CT_RABoss_Announce(CT_RABOSS_NOTH_BLINKSOON, CT_RABoss_Mods["역병술사 노스"]["announce"]);
		CT_RABoss_PlaySound(3);

	elseif ( event == "teleportwarn" ) then
		CT_RABoss_Announce(CT_RABOSS_NOTH_TELEPORT_10SEC, CT_RABoss_Mods["역병술사 노스"]["announce"]);
		CT_RABoss_PlaySound(3);

	elseif ( event == "nothsoon" ) then
		CT_RABoss_Announce(CT_RABOSS_NOTH_BACK_10SEC, CT_RABoss_Mods["역병술사 노스"]["announce"]);
		CT_RABoss_PlaySound(3);

	end
end


-- Heigan the Unclean (19/08/2006) - Changed naming.
function CT_RABoss_Heigan_OnLoad()
	CT_RABoss_AddMod("부정의 헤이건", CT_RABOSS_HEIGAN_INFO, 1, CT_RABOSS_LOCATIONS_NAXXRAMAS);
	CT_RABoss_AddEvent("부정의 헤이건", "CHAT_MSG_MONSTER_YELL", CT_RABoss_Heigan_EventHandler);
	CT_RABoss_AddEvent("부정의 헤이건", "CHAT_MSG_MONSTER_EMOTE", CT_RABoss_Heigan_EventHandler);

	CT_RABoss_AddDropDownButton("부정의 헤이건", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
end

function CT_RABoss_Heigan_EventHandler(event)
	if ( not CT_RABoss_Mods["부정의 헤이건"] or not CT_RABoss_Mods["부정의 헤이건"]["status"] or not CT_RABoss_Mods["부정의 헤이건"].enabled ) then
		return;
	end

	if ( event == "CHAT_MSG_MONSTER_YELL" ) then
		if ( arg1 == CT_RABOSS_HEIGAN_PHASE1_YELL1 or arg1 == CT_RABOSS_HEIGAN_PHASE1_YELL2 or arg1 == CT_RABOSS_HEIGAN_PHASE1_YELL3 ) then
			CT_RABoss_Announce(CT_RABOSS_HEIGAN_ENGAGED, CT_RABoss_Mods["부정의 헤이건"]["announce"]);
			CT_RABoss_PlaySound(3);
			CT_RABoss_UnSchedule("CT_RABoss_Heigan_EventHandler");
			CT_RABoss_Schedule("CT_RABoss_Heigan_EventHandler", 80, "teleportwarn");

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["부정의 헤이건"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_HEIGAN_TELEPORT, "90", "0*255*0"));
			end

		elseif ( arg1 == CT_RABOSS_HEIGAN_PHASE2_YELL1 ) then
			CT_RABoss_Announce(CT_RABOSS_HEIGAN_TELEPORTED, CT_RABoss_Mods["부정의 헤이건"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_UnSchedule("CT_RABoss_Heigan_EventHandler", "teleportwarn");
			CT_RABoss_Schedule("CT_RABoss_Heigan_EventHandler", 42, "backsoon");
			CT_RABoss_Schedule("CT_RABoss_Heigan_EventHandler", 45, "backinroom");

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["부정의 헤이건"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_HEIGAN_DANCE, "45", "255*0*0"));
			end
		end

	elseif ( event == "CHAT_MSG_MONSTER_EMOTE" and arg2 == CT_RABOSS_HEIGAN_BOSSNAME ) then
		if ( arg1 == CT_RABOSS_HEIGAN_DEAD ) then
			CT_RABoss_UnSchedule("CT_RABoss_Heigan_EventHandler");
		end

	elseif ( event == "backinroom" ) then
		CT_RABoss_Announce(CT_RABOSS_HEIGAN_BACK, CT_RABoss_Mods["부정의 헤이건"]["announce"]);
		CT_RABoss_PlaySound(2);
		CT_RABoss_Schedule("CT_RABoss_Heigan_EventHandler", 80, "teleportwarn");

		if ( CT_RA_Level >= 1 and CT_RABoss_Mods["부정의 헤이건"]["announce"] ) then
			CT_RA_SendMessage("AaO b1 t20 n*Teleport* f90 r0*255*0");
		end

	elseif ( event == "teleportwarn" ) then
		CT_RABoss_Announce(CT_RABOSS_HEIGAN_TELEPORT_10SEC, CT_RABoss_Mods["부정의 헤이건"]["announce"]);
		CT_RABoss_PlaySound(3);

	elseif ( event == "backsoon" ) then
		CT_RABoss_Announce(CT_RABOSS_HEIGAN_BACK_3SEC, CT_RABoss_Mods["부정의 헤이건"]["announce"]);
		CT_RABoss_PlaySound(3);
	end
end

-- Loatheb (22/08/2006) - Updated to use chat_msg_addon.
function CT_RABoss_Loatheb_OnLoad()
	CT_RABoss_AddMod("로데브", CT_RABOSS_LOATHEB_INFO, 1, CT_RABOSS_LOCATIONS_NAXXRAMAS);
	CT_RABoss_AddEvent("로데브", "PLAYER_REGEN_DISABLED", CT_RABoss_Loatheb_EventHandler);
	CT_RABoss_AddEvent("로데브", "CHAT_MSG_ADDON", CT_RABoss_Loatheb_EventHandler);
	CT_RABoss_AddEvent("로데브", "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE", CT_RABoss_Loatheb_EventHandler);
	CT_RABoss_AddEvent("로데브", "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE", CT_RABoss_Loatheb_EventHandler);
	CT_RABoss_AddEvent("로데브", "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE", CT_RABoss_Loatheb_EventHandler);
	CT_RABoss_AddEvent("로데브", "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF", CT_RABoss_Loatheb_EventHandler);

	CT_RABoss_AddDropDownButton("로데브", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
	CT_RABoss_AddDropDownButton("로데브", { CT_RABOSS_LOATHEB_CURSES_ALERT, CT_RABOSS_LOATHEB_CURSES_ALERT_INFO }, "CT_RABoss_ModInfo", "enablecurseS", "CT_RABoss_SetInfo");

	CT_RABoss_SetVar("로데브", "enablecurses", 1);
end

function CT_RABoss_Loatheb_Start()
	CT_RABoss_Announce(CT_RABOSS_LOATHEB_ENGAGE, CT_RABoss_Mods["로데브"]["announce"]);
	CT_RABoss_PlaySound(3);	
	CT_RABoss_Mods["로데브"]["lastaction"] = time();
	CT_RABoss_Mods["로데브"]["engaged"] = true;
	CT_RABoss_Schedule("CT_RABoss_Loatheb_EventHandler", 110, "doom5");

	if ( CT_RA_Level >= 1 and CT_RABoss_Mods["로데브"]["announce"] ) then
		CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_LOATHEB_DOOM_TIMER, "115", "255*0*0"));
	end
end

function CT_RABoss_Loatheb_EventHandler(event)
	if ( not CT_RABoss_Mods["로데브"] or not CT_RABoss_Mods["로데브"]["status"] or not CT_RABoss_Mods["로데브"].enabled ) then
		return;
	end

	if ( CT_RABoss_Mods["로데브"]["engaged"] and ( not CT_RABoss_Mods["로데브"]["lastaction"] or ( time() - CT_RABoss_Mods["로데브"]["lastaction"] ) > 60 ) ) then
		CT_RABoss_Mods["로데브"]["engaged"] = false;
		CT_RABoss_Mods["로데브"]["countdoom"] = nil;
	end

	if ( event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE" or event == "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE" or event == "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE" ) then
		if ( string.find(arg1, CT_RABOSS_LOATHEB_DOOM_STRING) and not CT_RABoss_Mods["로데브"]["doomtrip"] ) then
			CT_RABoss_Announce(CT_RABOSS_LOATHEB_DOOM_WARN, CT_RABoss_Mods["로데브"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_UnSchedule("CT_RABoss_Loatheb_EventHandler", "doom5");
			CT_RABoss_Schedule("CT_RABoss_Loatheb_EventHandler", 5, "undoom");
			CT_RABoss_Mods["로데브"]["doomtrip"] = true;
			CT_RABoss_Mods["로데브"]["engaged"] = true;
			CT_RABoss_Mods["로데브"]["lastaction"] = time();

			if ( CT_RABoss_Mods["로데브"]["countdoom"] ) then
				CT_RABoss_Mods["로데브"]["countdoom"] = CT_RABoss_Mods["로데브"]["countdoom"]+1;
			else
				CT_RABoss_Mods["로데브"]["countdoom"] = 0;
			end
			
			if ( CT_RABoss_Mods["로데브"]["countdoom"] > 7 ) then
				CT_RABoss_Schedule("CT_RABoss_Loatheb_EventHandler", 10, "doom5");

				if ( CT_RA_Level >= 1 and CT_RABoss_Mods["로데브"]["announce"] ) then
					CT_RA_SendMessage(format(CT_RABOSS_MUKKA_STRING, "1", "20", CT_RABOSS_LOATHEB_DOOM_TIMER, "15", "255*0*0"));
				end
			else
				CT_RABoss_Schedule("CT_RABoss_Loatheb_EventHandler", 25, "doom5");

				if ( CT_RA_Level >= 1 and CT_RABoss_Mods["로데브"]["announce"] ) then
					CT_RA_SendMessage(format(CT_RABOSS_MUKKA_STRING, "1", "20", CT_RABOSS_LOATHEB_DOOM_TIMER, "30", "255*0*0"));
				end
			end
		end
		
	elseif ( event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF" ) then
		if ( arg1 == CT_RABOSS_LOATHEB_CURSE_STRING and CT_RABoss_Mods["로데브"]["enablecurses"] ) then
			CT_RABoss_Announce(CT_RABOSS_LOATHEB_CURSE_WARN, CT_RABoss_Mods["로데브"]["announce"]);
			CT_RABoss_PlaySound(3);

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["로데브"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "2", "20", CT_RABOSS_LOATHEB_CURSE_TIMER, "30", "0*0*255"));
			end
		end
		
	elseif ( event == "PLAYER_REGEN_DISABLED" and not CT_RABoss_Mods["로데브"]["engaged"] ) then
		CT_RABoss_Schedule("CT_RABoss_Loatheb_EventHandler", 5, "engagecheck");	

	elseif ( event == "CHAT_MSG_ADDON" and arg1 == "CTRA" ) then
		if ( arg2 == "LOATHEBENGSYNC" and not CT_RABoss_Mods["로데브"]["engaged"] ) then
			CT_RABoss_Loatheb_Start();
		end

	elseif ( event == "engagecheck" and not CT_RABoss_Mods["로데브"]["engaged"] ) then
		if ( UnitName("target") == CT_RABOSS_LOATHEB_BOSSNAME and UnitAffectingCombat("target") ) then
			CT_RABoss_Loatheb_Start();
			CT_RA_SendMessage("LOATHEBENGSYNC");

		elseif ( UnitName("playertarget") == CT_RABOSS_LOATHEB_BOSSNAME and UnitAffectingCombat("playertarget") ) then
			CT_RABoss_Loatheb_Start();
			CT_RA_SendMessage("LOATHEBENGSYNC");
		else
			local i
			for i = 1, GetNumRaidMembers(), 1 do
				if ( UnitName("raid"..i.."target") == CT_RABOSS_LOATHEB_BOSSNAME and UnitAffectingCombat("raid"..i.."target")) then
					CT_RABoss_Loatheb_Start();
					CT_RA_SendMessage("LOATHEBENGSYNC");
					break;
				end
			end
		end

	elseif ( event == "doom5") then
		CT_RABoss_Announce(CT_RABOSS_LOATHEB_DOOM_5SEC, CT_RABoss_Mods["로데브"]["announce"]);
		CT_RABoss_PlaySound(3);

	elseif ( event == "undoom") then
		CT_RABoss_Mods["로데브"]["doomtrip"] = false;
	end
end

-- Deathknight Wing

-- Instructor Razuvious (01/09/2006) - Added shieldwall anouncements.
function CT_RABoss_Razuvious_OnLoad()
	CT_RABoss_AddMod("훈련교관 라주비어스", CT_RABOSS_RAZUVIOUS_INFO, 1, CT_RABOSS_LOCATIONS_NAXXRAMAS);
	CT_RABoss_AddEvent("훈련교관 라주비어스", "CHAT_MSG_MONSTER_YELL", CT_RABoss_Razuvious_EventHandler);
	CT_RABoss_AddEvent("훈련교관 라주비어스", "CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE", CT_RABoss_Razuvious_EventHandler);
	CT_RABoss_AddEvent("훈련교관 라주비어스", "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE", CT_RABoss_Razuvious_EventHandler);
	CT_RABoss_AddEvent("훈련교관 라주비어스", "CHAT_MSG_SPELL_CREATURE_VS_PARTY_DAMAGE", CT_RABoss_Razuvious_EventHandler);
	CT_RABoss_AddEvent("훈련교관 라주비어스", "CHAT_MSG_COMBAT_CREATURE_VS_CREATURE_HITS", CT_RABoss_Razuvious_EventHandler);
	CT_RABoss_AddEvent("훈련교관 라주비어스", "CHAT_MSG_COMBAT_CREATURE_VS_PARTY_HITS", CT_RABoss_Razuvious_EventHandler);
	CT_RABoss_AddEvent("훈련교관 라주비어스", "CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS", CT_RABoss_Razuvious_EventHandler);
	CT_RABoss_AddEvent("훈련교관 라주비어스", "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_BUFFS", CT_RABoss_Razuvious_EventHandler);
	CT_RABoss_AddEvent("훈련교관 라주비어스", "CHAT_MSG_SPELL_PERIODIC_PARTY_BUFFS", CT_RABoss_Razuvious_EventHandler);
	CT_RABoss_AddEvent("훈련교관 라주비어스", "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS", CT_RABoss_Razuvious_EventHandler);
	CT_RABoss_AddEvent("훈련교관 라주비어스", "CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS", CT_RABoss_Razuvious_EventHandler);

	CT_RABoss_AddDropDownButton("훈련교관 라주비어스", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
end

function CT_RABoss_Razuvious_EventHandler(event)
	if ( not CT_RABoss_Mods["훈련교관 라주비어스"] or not CT_RABoss_Mods["훈련교관 라주비어스"]["status"] or not CT_RABoss_Mods["훈련교관 라주비어스"].enabled ) then
		return;
	end

	if ( event == "CHAT_MSG_MONSTER_YELL" ) then
		if ( arg1 == CT_RABOSS_RAZUVIOUS_YELL1 or arg1 == CT_RABOSS_RAZUVIOUS_YELL2 or arg1 == CT_RABOSS_RAZUVIOUS_YELL3 or arg1 == CT_RABOSS_RAZUVIOUS_YELL4 ) then
			CT_RABoss_Announce(CT_RABOSS_RAZUVIOUS_ENGAGED, CT_RABoss_Mods["훈련교관 라주비어스"]["announce"]);
			CT_RABoss_PlaySound(3);
			CT_RABoss_UnSchedule("CT_RABoss_Razuvious_EventHandler");
			CT_RABoss_Schedule("CT_RABoss_Razuvious_EventHandler", 15.5, "warn10");
			CT_RABoss_Mods["훈련교관 라주비어스"]["lastaction"] = time();

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["훈련교관 라주비어스"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "25.5", CT_RABOSS_RAZUVIOUS_SHOUT, "25.5", "255*0*0"));
			end

		elseif ( arg1 == CT_RABOSS_MRRAZUVIOUS_DEAD_YELL1 ) then
			CT_RABoss_UnSchedule("CT_RABoss_Razuvious_EventHandler");
		end

	elseif ( event == "CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE" or event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE" or event == "CHAT_MSG_SPELL_CREATURE_VS_PARTY_DAMAGE" ) then
		if ( string.find(arg1, CT_RABOSS_RAZUVIOUS_SHOUT) and not CT_RABoss_Mods["훈련교관 라주비어스"]["shouttrip"] ) then
			CT_RABoss_UnSchedule("CT_RABoss_Razuvious_EventHandler");
			CT_RABoss_Schedule("CT_RABoss_Razuvious_EventHandler", 15.5, "warn10");
			CT_RABoss_Schedule("CT_RABoss_Razuvious_EventHandler", 5, "preshout");
			CT_RABoss_Mods["훈련교관 라주비어스"]["shouttrip"] = true;
			CT_RABoss_Mods["훈련교관 라주비어스"]["lastaction"] = time();

			if ( not CT_RABoss_Mods["훈련교관 라주비어스"]["shoutwarn"] ) then
				CT_RABoss_Announce(CT_RABOSS_RAZUVIOUS_SHOUTNEXT, CT_RABoss_Mods["훈련교관 라주비어스"]["announce"]);
				CT_RABoss_PlaySound(2);
			end

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["훈련교관 라주비어스"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "25.5", CT_RABOSS_RAZUVIOUS_SHOUT, "25.5", "255*0*0"));
			end
		end

	elseif ( event == "CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS" or event == "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_BUFFS" or event == "CHAT_MSG_SPELL_PERIODIC_PARTY_BUFFS" or event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS" ) then
		if ( arg1 == CT_RABOSS_MRRAZUVIOUS_SHIELDSTRING ) then
			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["훈련교관 라주비어스"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "2", "20", CT_RABOSS_RAZUVIOUS_SHIELDWALL, "20", "0*0*255"));
			end
		end	

	elseif ( event == "CHAT_MSG_COMBAT_CREATURE_VS_CREATURE_HITS" or event == "CHAT_MSG_COMBAT_CREATURE_VS_PARTY_HITS" or event == "CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS" ) then
		if ( string.find(arg1, CT_RABOSS_RAZUVIOUS_BOSSNAME) or string.find(arg1, CT_RABOSS_RAZUVIOUS_STUDENT) ) then
			CT_RABoss_Mods["훈련교관 라주비어스"]["lastaction"] = time();
		end

	elseif ( event == "preshout" ) then
		CT_RABoss_Mods["훈련교관 라주비어스"]["shouttrip"] = false;

	elseif ( event == "warn10" ) then
		CT_RABoss_Announce(format(CT_RABOSS_RAZUVIOUS_SHOUTWARN, "10"), CT_RABoss_Mods["훈련교관 라주비어스"]["announce"]);
		CT_RABoss_PlaySound(3);
		CT_RABoss_Schedule("CT_RABoss_Razuvious_EventHandler", 5, "warn5");
		CT_RABoss_Mods["훈련교관 라주비어스"]["shoutwarn"] = false;

	elseif ( event == "warn5" ) then
		CT_RABoss_Announce(format(CT_RABOSS_RAZUVIOUS_SHOUTWARN, "5"), CT_RABoss_Mods["훈련교관 라주비어스"]["announce"]);
		CT_RABoss_PlaySound(3);
		CT_RABoss_Schedule("CT_RABoss_Razuvious_EventHandler", 2, "warn3");

	elseif ( event == "warn3" ) then
		CT_RABoss_Announce(format(CT_RABOSS_RAZUVIOUS_SHOUTWARN, "3"), CT_RABoss_Mods["훈련교관 라주비어스"]["announce"]);
		CT_RABoss_PlaySound(3);
		CT_RABoss_Schedule("CT_RABoss_Razuvious_EventHandler", 3, "shoutcast");

	elseif ( event == "shoutcast" ) then
		if ( not CT_RABoss_Mods["훈련교관 라주비어스"]["lastaction"] or ( time() - CT_RABoss_Mods["훈련교관 라주비어스"]["lastaction"] ) > 30 ) then
			return;
		else
			CT_RABoss_Mods["훈련교관 라주비어스"]["shoutwarn"] = true;
			CT_RABoss_Announce(CT_RABOSS_RAZUVIOUS_SHOUTNEXT, CT_RABoss_Mods["훈련교관 라주비어스"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_Schedule("CT_RABoss_Razuvious_EventHandler", 15, "warn10");

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["훈련교관 라주비어스"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "25", CT_RABOSS_RAZUVIOUS_SHOUT, "25", "255*0*0"));
			end
		end
	end
end


-- Gothik the Harvester (19/08/2006) - Changed naming.
function CT_RABoss_Gothik_OnLoad()
	CT_RABoss_AddMod("영혼의 착취자 고딕", CT_RABOSS_GOTHIK_INFO, 1, CT_RABOSS_LOCATIONS_NAXXRAMAS);
	CT_RABoss_AddEvent("영혼의 착취자 고딕", "CHAT_MSG_MONSTER_YELL", CT_RABoss_Gothik_EventHandler);
	CT_RABoss_AddEvent("영혼의 착취자 고딕", "CHAT_MSG_COMBAT_HOSTILE_DEATH", CT_RABoss_Gothik_EventHandler);

	CT_RABoss_AddDropDownButton("영혼의 착취자 고딕", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
end

function CT_RABoss_Gothik_EventHandler(event)
	if ( not CT_RABoss_Mods["영혼의 착취자 고딕"] or not CT_RABoss_Mods["영혼의 착취자 고딕"]["status"] or not CT_RABoss_Mods["영혼의 착취자 고딕"].enabled ) then
		return;
	end

	if ( event == "CHAT_MSG_MONSTER_YELL" ) then
		if ( string.find(arg1, CT_RABOSS_GOTHIK_PHASE1_YELL1) ) then
			CT_RABoss_Announce(CT_RABOSS_GOTHIK_ENGAGED, CT_RABoss_Mods["영혼의 착취자 고딕"]["announce"]);
			CT_RABoss_PlaySound(3);
			CT_RABoss_Schedule("CT_RABoss_Gothik_EventHandler", 34, "inctimer");
			CT_RABoss_Schedule("CT_RABoss_Gothik_EventHandler", 24, "inctrainee");
			CT_RABoss_Schedule("CT_RABoss_Gothik_EventHandler", 74, "incknight");
			CT_RABoss_Schedule("CT_RABoss_Gothik_EventHandler", 134, "incrider");
			CT_RABoss_Mods["영혼의 착취자 고딕"]["timeleft"] = 4;
			CT_RABoss_Mods["영혼의 착취자 고딕"]["stoptimer"] = false;
			CT_RABoss_Mods["영혼의 착취자 고딕"]["lastaction"] = time();

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["영혼의 착취자 고딕"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_GOTHIK_TRAINEES, "20", "0*255*0"));
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "2", "20", CT_RABOSS_GOTHIK_KNIGHTS, "70", "0*0*255"));
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "3", "20", CT_RABOSS_GOTHIK_RIDERS, "130", "255*0*0"));
			end

		elseif ( arg1 == CT_RABOSS_GOTHIK_PHASE2_YELL1 ) then
			CT_RABoss_Announce(CT_RABOSS_GOTHIK_INC, CT_RABoss_Mods["영혼의 착취자 고딕"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_Mods["영혼의 착취자 고딕"]["stoptimer"] = true;
		end
	
	elseif ( event == "CHAT_MSG_COMBAT_HOSTILE_DEATH" ) then
		if ( string.find(arg1, CT_RABOSS_GOTHIK_TRAINEE) ) then
			CT_RABoss_Mods["영혼의 착취자 고딕"]["lastaction"] = time();

		elseif ( string.find(arg1, CT_RABOSS_GOTHIK_KNIGHT) ) then
			CT_RABoss_Announce(CT_RABOSS_GOTHIK_KNIGHT_DEAD, CT_RABoss_Mods["영혼의 착취자 고딕"]["announce"]);
			CT_RABoss_Mods["영혼의 착취자 고딕"]["lastaction"] = time();

		elseif ( string.find(arg1, CT_RABOSS_GOTHIK_RIDER) ) then
			CT_RABoss_Announce(CT_RABOSS_GOTHIK_RIDER_DEAD, CT_RABoss_Mods["영혼의 착취자 고딕"]["announce"]);
			CT_RABoss_Mods["영혼의 착취자 고딕"]["lastaction"] = time();
		end

	elseif ( event == "inctimer") then
		if ( not CT_RABoss_Mods["영혼의 착취자 고딕"]["lastaction"] or ( time() - CT_RABoss_Mods["영혼의 착취자 고딕"]["lastaction"] ) > 45 ) then
			CT_RABoss_Mods["영혼의 착취자 고딕"]["stoptimer"] = true;

		elseif ( CT_RABoss_Mods["영혼의 착취자 고딕"]["timeleft"] == 0.5 ) then
			CT_RABoss_Schedule("CT_RABoss_Gothik_EventHandler", 20, "inc10");
			CT_RABoss_Announce(format(CT_RABOSS_GOTHIK_SECWARN, "30"), CT_RABoss_Mods["영혼의 착취자 고딕"]["announce"]);
			CT_RABoss_PlaySound(3);
		else
			if ( CT_RABoss_Mods["영혼의 착취자 고딕"]["timeleft"] == 1 ) then
				CT_RABoss_Announce(CT_RABOSS_GOTHIK_1MINWARN, CT_RABoss_Mods["영혼의 착취자 고딕"]["announce"]);
			else
				CT_RABoss_Announce(format(CT_RABOSS_GOTHIK_WARN, CT_RABoss_Mods["영혼의 착취자 고딕"]["timeleft"]), CT_RABoss_Mods["영혼의 착취자 고딕"]["announce"]);
			end

			CT_RABoss_Mods["영혼의 착취자 고딕"]["timeleft"] = CT_RABoss_Mods["영혼의 착취자 고딕"]["timeleft"]-0.5;
			CT_RABoss_Schedule("CT_RABoss_Gothik_EventHandler", 30, "inctimer");
			CT_RABoss_PlaySound(3);
		end

	elseif ( event == "inctrainee" and not CT_RABoss_Mods["영혼의 착취자 고딕"]["stoptimer"] ) then
		CT_RABoss_Announce(format(CT_RABOSS_GOTHIK_ADD_INC, CT_RABOSS_GOTHIK_TRAINEES), CT_RABoss_Mods["영혼의 착취자 고딕"]["announce"]);
		CT_RABoss_PlaySound(3);
		CT_RABoss_Schedule("CT_RABoss_Gothik_EventHandler", 20, "inctrainee");

		if ( CT_RA_Level >= 1 and CT_RABoss_Mods["영혼의 착취자 고딕"]["announce"] ) then
			CT_RA_SendMessage(format(CT_RABOSS_MUKKA_STRING, "1", "20", CT_RABOSS_GOTHIK_TRAINEES, "20", "0*255*0"));
		end

	elseif ( event == "incknight" and not CT_RABoss_Mods["영혼의 착취자 고딕"]["stoptimer"] ) then
		CT_RABoss_Announce(format(CT_RABOSS_GOTHIK_ADD_INC, CT_RABOSS_GOTHIK_KNIGHTS), CT_RABoss_Mods["영혼의 착취자 고딕"]["announce"]);
		CT_RABoss_PlaySound(3);
		CT_RABoss_Schedule("CT_RABoss_Gothik_EventHandler", 25, "incknight");

		if ( CT_RA_Level >= 1 and CT_RABoss_Mods["영혼의 착취자 고딕"]["announce"] ) then
			CT_RA_SendMessage(format(CT_RABOSS_MUKKA_STRING, "2", "25", CT_RABOSS_GOTHIK_KNIGHTS, "25", "0*0*255"));
		end

	elseif ( event == "incrider" and not CT_RABoss_Mods["영혼의 착취자 고딕"]["stoptimer"] ) then
		CT_RABoss_Announce(format(CT_RABOSS_GOTHIK_ADD_INC, CT_RABOSS_GOTHIK_RIDERS), CT_RABoss_Mods["영혼의 착취자 고딕"]["announce"]);
		CT_RABoss_PlaySound(3);
		CT_RABoss_Schedule("CT_RABoss_Gothik_EventHandler", 30, "incrider");

		if ( CT_RA_Level >= 1 and CT_RABoss_Mods["영혼의 착취자 고딕"]["announce"] ) then
			CT_RA_SendMessage(format(CT_RABOSS_MUKKA_STRING, "3", "30", CT_RABOSS_GOTHIK_RIDERS, "30", "255*0*0"));
		end

	elseif ( event == "inc10" ) then
		CT_RABoss_Announce(format(CT_RABOSS_GOTHIK_SECWARN, "10"), CT_RABoss_Mods["영혼의 착취자 고딕"]["announce"]);
		CT_RABoss_PlaySound(3);

	end
end

-- The Four Horsemen (02/09/2006) - New code.
function CT_RABoss_Horsemen_OnLoad()
	CT_RABoss_AddMod("4인의 기사단", CT_RABOSS_HORSEMEN_INFO, 1, CT_RABOSS_LOCATIONS_NAXXRAMAS);
	CT_RABoss_AddEvent("4인의 기사단", "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS", CT_RABoss_Horsemen_EventHandler);
	CT_RABoss_AddEvent("4인의 기사단", "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF", CT_RABoss_Horsemen_EventHandler);
	CT_RABoss_AddEvent("4인의 기사단", "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE", CT_RABoss_Horsemen_EventHandler);
	CT_RABoss_AddEvent("4인의 기사단", "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE", CT_RABoss_Horsemen_EventHandler);
	CT_RABoss_AddEvent("4인의 기사단", "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE", CT_RABoss_Horsemen_EventHandler);
	CT_RABoss_AddEvent("4인의 기사단", "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE", CT_RABoss_Horsemen_EventHandler);

	CT_RABoss_AddDropDownButton("4인의 기사단", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
end

function CT_RABoss_Horsemen_Start()
	CT_RABoss_Announce(CT_RABOSS_HORSEMEN_ENGAGE, CT_RABoss_Mods["4인의 기사단"]["announce"]);
	CT_RABoss_PlaySound(3);
	CT_RABoss_Mods["4인의 기사단"]["engaged"] = true;
	CT_RABoss_Mods["4인의 기사단"]["marks"] = 1;
	CT_RABoss_Schedule("CT_RABoss_Horsemen_EventHandler", 7, "mark5");

	if ( CT_RA_Level >= 1 and CT_RABoss_Mods["4인의 기사단"]["announce"] ) then
		CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "12", CT_RABOSS_HORSEMEN_MARK, "12", "255*0*0"));
	end
end

function CT_RABoss_Horsemen_EventHandler(event)
	if ( event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE" or event == "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE" ) then
		if ( not string.find(arg1, "사냥꾼") and string.find(arg1, CT_RABOSS_HORSEMEN_MARKSTRING) ) then
			CT_RABoss_Announce(format(CT_RABOSS_HORSEMEN_MARKNOW, CT_RABoss_Mods["4인의 기사단"]["marks"]), CT_RABoss_Mods["4인의 기사단"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_Schedule("CT_RABoss_Horsemen_EventHandler", 7, "mark5");
			CT_RABoss_Mods["4인의 기사단"]["engaged"] = true;
			CT_RABoss_Mods["4인의 기사단"]["marks"] = CT_RABoss_Mods["4인의 기사단"]["marks"] + 1;

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["4인의 기사단"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "12", CT_RABOSS_HORSEMEN_MARK, "12", "255*0*0"));
			end
		end

	elseif ( event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE" or event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF" ) then
		if ( string.find(arg1, CT_RABOSS_HORSEMEN_VOIDSTRING) ) then
			CT_RABoss_Announce(CT_RABOSS_HORSEMEN_VOIDWARN, CT_RABoss_Mods["4인의 기사단"]["announce"]);
			CT_RABoss_PlaySound(3);

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["4인의 기사단"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MUKKA_STRING, "2", "12", CT_RABOSS_HORSEMEN_VOID, "12", "255*0*0"));
			end

		elseif ( string.find(arg1, CT_RABOSS_HORSEMEN_METEORSTRING) and not CT_RABoss_Mods["4인의 기사단"]["meteortrip"]) then
			CT_RABoss_Announce(CT_RABOSS_HORSEMEN_METEORWARN, CT_RABoss_Mods["4인의 기사단"]["announce"]);
			CT_RABoss_PlaySound(3);
			CT_RABoss_Mods["4인의 기사단"]["meteortrip"] = true;
			CT_RABoss_Schedule("CT_RABoss_Horsemen_EventHandler", 5, "unmeteor");

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["4인의 기사단"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "3", "12", CT_RABOSS_HORSEMEN_METEOR, "12", "255*0*0"));
			end

		elseif ( string.find(arg1, CT_RABOSS_HORSEMEN_WRATHSTRING) and not CT_RABoss_Mods["4인의 기사단"]["wrathtrip"] ) then
			CT_RABoss_Announce(CT_RABOSS_HORSEMEN_WRATHWARN, CT_RABoss_Mods["4인의 기사단"]["announce"]);
			CT_RABoss_PlaySound(3);
			CT_RABoss_Mods["4인의 기사단"]["wrathtrip"] = true;
			CT_RABoss_Schedule("CT_RABoss_Horsemen_EventHandler", 5, "unwrath");

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["4인의 기사단"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "4", "12", CT_RABOSS_HORSEMEN_WRATH, "12", "255*0*0"));
			end
		end

	elseif ( event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS" ) then
		if ( string.find(arg1, CT_RABOSS_HORSEMEN_SHIELDSTRING) ) then
			if ( string.find(arg1, CT_RABOSS_HORSEMEN_THANE) ) then
				CT_RABoss_Announce(format(CT_RABOSS_HORSEMEN_SHIELDWARN, CT_RABOSS_HORSEMEN_THANE), CT_RABoss_Mods["4인의 기사단"]["announce"]);
				CT_RABoss_PlaySound(2);
				CT_RABoss_Schedule("CT_RABoss_Horsemen_EventHandler", 20, "shieldover"..CT_RABOSS_HORSEMEN_THANE);

			elseif ( string.find(arg1, CT_RABOSS_HORSEMEN_MOGRAINE) ) then
				CT_RABoss_Announce(format(CT_RABOSS_HORSEMEN_SHIELDWARN, CT_RABOSS_HORSEMEN_MOGRANE), CT_RABoss_Mods["4인의 기사단"]["announce"]);
				CT_RABoss_PlaySound(2);
				CT_RABoss_Schedule("CT_RABoss_Horsemen_EventHandler", 20, "shieldover"..CT_RABOSS_HORSEMEN_MOGRANE);	

			elseif ( string.find(arg1, CT_RABOSS_HORSEMEN_ZELIEK) ) then
				CT_RABoss_Announce(format(CT_RABOSS_HORSEMEN_SHIELDWARN, CT_RABOSS_HORSEMEN_ZELIEK), CT_RABoss_Mods["4인의 기사단"]["announce"]);
				CT_RABoss_PlaySound(2);
				CT_RABoss_Schedule("CT_RABoss_Horsemen_EventHandler", 20, "shieldover"..CT_RABOSS_HORSEMEN_ZELIEK);

			elseif ( string.find(arg1, CT_RABOSS_HORSEMEN_BLAUMEUX) ) then
				CT_RABoss_Announce(format(CT_RABOSS_HORSEMEN_SHIELDWARN, CT_RABOSS_HORSEMEN_BLAUMEUX), CT_RABoss_Mods["4인의 기사단"]["announce"]);
				CT_RABoss_PlaySound(2);
				CT_RABoss_Schedule("CT_RABoss_Horsemen_EventHandler", 20, "shieldover"..CT_RABOSS_HORSEMEN_BLAUMEUX);
			end
		end

	elseif ( strsub( event, 1, 10 ) == "shieldover" ) then
		local bossname = strsub( event, 11 );
		CT_RABoss_Announce(format(CT_RABOSS_HORSEMEN_SHIELDOVER, bossname), CT_RABoss_Mods["4인의 기사단"]["announce"]);
		CT_RABoss_PlaySound(3);

	elseif ( event == "PLAYER_REGEN_DISABLED" and not CT_RABoss_Mods["4인의 기사단"]["engaged"] ) then
		CT_RABoss_Schedule("CT_RABoss_Horsemen_EventHandler", 5, "engagecheck");	

	elseif ( event == "CHAT_MSG_ADDON" and arg1 == "CTRA" ) then
		if ( arg2 == "HORSEMENENGSYNC" and not CT_RABoss_Mods["4인의 기사단"]["engaged"] ) then
			CT_RABoss_Horsemen_Start();
		end

	elseif ( event == "engagecheck" and not CT_RABoss_Mods["4인의 기사단"]["engaged"] ) then
		if ( ( UnitName("target") == CT_RABOSS_HORSEMEN_THANE or UnitName("target") == CT_RABOSS_HORSEMEN_MOGRAINE or UnitName("target") == CT_RABOSS_HORSEMEN_ZELIEK or UnitName("target") == CT_RABOSS_HORSEMEN_BLAUMEUX ) and UnitAffectingCombat("target") ) then
			CT_RABoss_Horsemen_Start();
			CT_RA_SendMessage("HORSEMENENGSYNC");

		elseif ( ( UnitName("playertarget") == CT_RABOSS_HORSEMEN_THANE or UnitName("playertarget") == CT_RABOSS_HORSEMEN_MOGRAINE or UnitName("playertarget") == CT_RABOSS_HORSEMEN_ZELIEK or UnitName("playertarget") == CT_RABOSS_HORSEMEN_BLAUMEUX ) and UnitAffectingCombat("playertarget") ) then
			CT_RABoss_Horsemen_Start();
			CT_RA_SendMessage("HORSEMENENGSYNC");
		else
			local i
			for i = 1, GetNumRaidMembers(), 1 do
				if ( ( UnitName("raid"..i.."target") == CT_RABOSS_HORSEMEN_THANE or UnitName("raid"..i.."target") == CT_RABOSS_HORSEMEN_MOGRAINE or UnitName("raid"..i.."target") == CT_RABOSS_HORSEMEN_ZELIEK or UnitName("raid"..i.."target") == CT_RABOSS_HORSEMEN_BLAUMEUX ) and UnitAffectingCombat("raid"..i.."target") ) then
					CT_RABoss_MHorsemen_Start();
					CT_RA_SendMessage("HORSEMENENGSYNC");
					break;
				end
			end
		end

	elseif ( event == "mark5" ) then
		CT_RABoss_Announce(format(CT_RABOSS_HORSEMEN_MARKWARN, CT_RABoss_Mods["4인의 기사단"]["marks"]), CT_RABoss_Mods["4인의 기사단"]["announce"]);
		CT_RABoss_PlaySound(3);

	elseif ( event == "unmeteor" ) then
		CT_RABoss_Mods["4인의 기사단"]["meteortrip"] = false;

	elseif ( event == "unwrath" ) then
		CT_RABoss_Mods["4인의 기사단"]["wrathtrip"] = false;

	end
end

-- Abomination Wing

-- Patchwerk - (19/08/2006) - Changed naming.
function CT_RABoss_Patchwerk_OnLoad()
	CT_RABoss_AddMod("패치워크", CT_RABOSS_PATCHWERK_INFO, 1, CT_RABOSS_LOCATIONS_NAXXRAMAS);
	CT_RABoss_AddEvent("패치워크", "CHAT_MSG_MONSTER_YELL", CT_RABoss_Patchwerk_EventHandler);
	CT_RABoss_AddEvent("패치워크", "CHAT_MSG_MONSTER_EMOTE", CT_RABoss_Patchwerk_EventHandler);
	CT_RABoss_AddEvent("패치워크", "CHAT_MSG_COMBAT_CREATURE_VS_CREATURE_HITS", CT_RABoss_Patchwerk_EventHandler);
	CT_RABoss_AddEvent("패치워크", "CHAT_MSG_COMBAT_CREATURE_VS_PARTY_HITS", CT_RABoss_Patchwerk_EventHandler);
	CT_RABoss_AddEvent("패치워크", "CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS", CT_RABoss_Patchwerk_EventHandler);

	CT_RABoss_AddDropDownButton("패치워크", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
end

function CT_RABoss_Patchwerk_EventHandler(event)
	if ( not CT_RABoss_Mods["패치워크"] or not CT_RABoss_Mods["패치워크"]["status"] or not CT_RABoss_Mods["패치워크"].enabled ) then
		return;
	end

	if ( event == "CHAT_MSG_MONSTER_YELL" ) then
		if ( arg1 == CT_RABOSS_PATCHWERK_YELL1 or arg1 == CT_RABOSS_PATCHWERK_YELL2 ) then
			CT_RABoss_Announce(CT_RABOSS_PATCHWERK_ENGAGED, CT_RABoss_Mods["패치워크"]["announce"]);
			CT_RABoss_PlaySound(3);
			CT_RABoss_Schedule("CT_RABoss_Patchwerk_EventHandler", 30, "enragetimer");
			CT_RABoss_Mods["패치워크"]["enrageleft"] = 6.5;
			CT_RABoss_Mods["패치워크"]["lastaction"] = time();

		elseif ( arg1 == CT_RABOSS_PATCHWERK_DEAD ) then
			CT_RABoss_UnSchedule("CT_RABoss_Patchwerk_EventHandler");
		end

	elseif ( event == "enragetimer") then
		if ( not CT_RABoss_Mods["패치워크"]["lastaction"] or ( time() - CT_RABoss_Mods["패치워크"]["lastaction"] ) > 30 ) then
			return;

		elseif ( CT_RABoss_Mods["패치워크"]["enrageleft"] == 0.5 ) then
			CT_RABoss_Schedule("CT_RABoss_Patchwerk_EventHandler", 15, "enrage15");
			CT_RABoss_Schedule("CT_RABoss_Patchwerk_EventHandler", 25, "enrage10");
			CT_RABoss_Announce(format(CT_RABOSS_PATCHWERK_SECWARN, "30"), CT_RABoss_Mods["패치워크"]["announce"]);
			CT_RABoss_PlaySound(3);
		else
			if ( CT_RABoss_Mods["패치워크"]["enrageleft"] == 1 ) then
				CT_RABoss_Announce(CT_RABOSS_PATCHWERK_1MINWARN, CT_RABoss_Mods["패치워크"]["announce"]);
			else
				CT_RABoss_Announce(format(CT_RABOSS_PATCHWERK_WARN, CT_RABoss_Mods["패치워크"]["enrageleft"]), CT_RABoss_Mods["패치워크"]["announce"]);
			end
			CT_RABoss_Mods["패치워크"]["enrageleft"] = CT_RABoss_Mods["패치워크"]["enrageleft"]-0.5;
			CT_RABoss_Schedule("CT_RABoss_Patchwerk_EventHandler", 30, "enragetimer");
			CT_RABoss_PlaySound(3);
		end

	elseif ( event == "CHAT_MSG_MONSTER_EMOTE" and arg2 == CT_RABOSS_PATCHWERK_BOSSNAME ) then
		if ( arg1 == CT_RABOSS_PATCHWERK_ENRAGESTRING ) then
			CT_RABoss_Announce(CT_RABOSS_PATCHWERK_ENRAGEWARNING, CT_RABoss_Mods["패치워크"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_Mods["패치워크"]["lastaction"] = time();

		elseif ( arg1 == CT_RABOSS_PATCHWERK_BERSERKSTRING ) then
			CT_RABoss_Announce(CT_RABOSS_PATCHWERK_BERSERKWARNING, CT_RABoss_Mods["패치워크"]["announce"]);
			CT_RABoss_PlaySound(1);
			CT_RABoss_UnSchedule("CT_RABoss_Patchwerk_EventHandler");
		end

	elseif ( event == "CHAT_MSG_COMBAT_CREATURE_VS_CREATURE_HITS" or event == "CHAT_MSG_COMBAT_CREATURE_VS_PARTY_HITS" or event == "CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS" ) then
		if ( string.find(arg1, CT_RABOSS_PATCHWERK_BOSSNAME) ) then
			CT_RABoss_Mods["패치워크"]["lastaction"] = time();
		end	

	elseif ( event == "enrage15" ) then
		CT_RABoss_Announce(format(CT_RABOSS_PATCHWERK_SECWARN, "15"), CT_RABoss_Mods["패치워크"]["announce"]);
		CT_RABoss_PlaySound(3);

	elseif ( event == "enrage5" ) then
		CT_RABoss_Announce(format(CT_RABOSS_PATCHWERK_SECWARN, "5"), CT_RABoss_Mods["패치워크"]["announce"]);
		CT_RABoss_PlaySound(3);
	end
end


-- Grobbulus - (19/08/2006) - Changed naming.
function CT_RABoss_Grobbulus_OnLoad()
	CT_RABoss_AddMod("그라불루스", CT_RABOSS_GROBBULUS_INFO, 1, CT_RABOSS_LOCATIONS_NAXXRAMAS);
	CT_RABoss_AddEvent("그라불루스", "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE", CT_RABoss_Grobbulus_EventHandler);
	CT_RABoss_AddEvent("그라불루스", "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE", CT_RABoss_Grobbulus_EventHandler);
	CT_RABoss_AddEvent("그라불루스", "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE", CT_RABoss_Grobbulus_EventHandler);

	CT_RABoss_AddDropDownButton("그라불루스", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
	CT_RABoss_AddDropDownButton("그라불루스", { CT_RABOSS_GROBBULUS_ALERT, CT_RABOSS_GROBBULUS_ALERT_INFO }, "CT_RABoss_ModInfo", "alertnearby", "CT_RABoss_SetInfo");
	CT_RABoss_AddDropDownButton("그라불루스", { CT_RABOSS_GROBBULUS_TELL, CT_RABOSS_GROBBULUS_TELL_INFO }, "CT_RABoss_ModInfo", "sendtell", "CT_RABoss_SetInfo");
	
	CT_RABoss_SetVar("그라불루스", "alertNearby", 1);
	CT_RABoss_Mods["그라불루스"]["icons"] = {false,false,false,false,false,false,false,false};
end

function CT_RABoss_Grobbulus_EventHandler(event)
	if ( not CT_RABoss_Mods["그라불루스"] or not CT_RABoss_Mods["그라불루스"]["status"] or not CT_RABoss_Mods["그라불루스"].enabled ) then
		return;
	end

	if ( event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE" or ( ( event == "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE" or event == "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE" ) and CT_RABoss_Mods["그라불루스"]["alertNearby"] ) ) then
		local playername;
		if ( string.find(arg1, "(.+) 유발에 걸렸습니다.") ) then
			if ( string.find(arg1, "(.+)%|1이;가; 돌연변이") ) then
				local _, _, playername2, playertype = string.find(arg1, CT_RABOSS_GROBBULUS_MIEXP);
				playername = playername2;
			elseif ( arg1 == CT_RABOSS_GROBBULUS_YOU ) then
				local iStart, iEnd, playername2 = string.find(arg1, "(.+) 유발에 걸렸습니다.");
				if ( playername2 == CT_RABOSS_GROBBULUS_TYPE_YOU ) then
					playername = playername2;
				end
			end
			if ( playername ) then
				if ( playername == CT_RABOSS_GROBBULUS_TYPE_YOU ) then
					playername = UnitName("player");
					CT_RABoss_Announce(CT_RABOSS_GROBBULUS_AFFLICTED_YOU);
					CT_RABoss_Announce(CT_RABOSS_GROBBULUS_AFFLICTED_YOU);
					CT_RABoss_PlaySound(2);

					if ( CT_RA_Level >= 1 and CT_RABoss_Mods["그라불루스"]["announce"] ) then
						CT_RA_AddMessage("MS " .. format(CT_RABOSS_GROBBULUS_AFFLICTED, playername));
					end
				
				elseif ( CT_RABoss_Mods["그라불루스"]["alertNearby"] or CT_RABoss_Mods["그라불루스"]["sendTell"] ) then
					if ( CT_RABoss_Mods["그라불루스"]["sendTell"] ) then
						SendChatMessage(CT_RABOSS_GROBBULUS_AFFLICTED_YOU, CT_RABOSS_GROBBULUS_AFFLICTED_WHISPER, nil, playername);
					end
					if ( CT_RABoss_Mods["그라불루스"]["alertNearby"] ) then
						CT_RABoss_Announce(format(CT_RABOSS_GROBBULUS_AFFLICTED, playername));
						CT_RABoss_PlaySound(3);
					end
				end

				if ( CT_RA_Level >= 1 and CT_RABoss_Mods["그라불루스"]["announce"] ) then
					local i,iconid;
					for i = 8, 1, -1 do
						if CT_RABoss_Mods["그라불루스"]["icons"][i] == false then
							iconid = i;
							break;
						end
					end

					local i;
					for i = 1, GetNumRaidMembers() do
						if ( UnitName("raid"..i) == playername and iconid ) then
							if ( not GetRaidTargetIndex("raid"..i) or ( not CT_RABoss_Mods["그라불루스"]["icons"][GetRaidTargetIndex("raid"..i)] == playername ) ) then
								SetRaidTargetIcon("raid"..i, iconid);
								CT_RABoss_Mods["그라불루스"]["icons"][iconid] = playername;
								CT_RABoss_Schedule("CT_RABoss_Grobbulus_EventHandler", 10, "removeicon"..playername);
								break;
							end
						end
					end
				end
			end
		end


	elseif ( strsub( event, 1, 10 ) == "removeicon" ) then
		if ( CT_RA_Level >= 1 and CT_RABoss_Mods["그라불루스"]["announce"] ) then
			local playername = strsub( event, 11 );
			if ( playername ) then
				local i;
				for i = 1, GetNumRaidMembers() do
					if ( UnitName("raid"..i) == playername and GetRaidTargetIndex("raid"..i) ) then
						CT_RABoss_Mods["그라불루스"]["icons"][GetRaidTargetIndex("raid"..i)] = false;
						SetRaidTargetIcon("raid"..i, 0);
						break;
					end
				end
			end
		end
	end
end

-- Gluth - (22/08/2006) - Changed over to chat_msg_addon.
function CT_RABoss_Gluth_OnLoad()
	CT_RABoss_AddMod("글루스", CT_RABOSS_GLUTH_INFO, 1, CT_RABOSS_LOCATIONS_NAXXRAMAS);
	CT_RABoss_AddEvent("글루스", "CHAT_MSG_MONSTER_EMOTE", CT_RABoss_Gluth_EventHandler);
	CT_RABoss_AddEvent("글루스", "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE", CT_RABoss_Gluth_EventHandler);	
	CT_RABoss_AddEvent("글루스", "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE", CT_RABoss_Gluth_EventHandler);
	CT_RABoss_AddEvent("글루스", "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE", CT_RABoss_Gluth_EventHandler);			
	CT_RABoss_AddEvent("글루스", "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS", CT_RABoss_Gluth_EventHandler);	
	CT_RABoss_AddEvent("글루스", "CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE", CT_RABoss_Gluth_EventHandler);
	CT_RABoss_AddEvent("글루스", "CHAT_MSG_SPELL_CREATURE_VS_PARTY_DAMAGE", CT_RABoss_Gluth_EventHandler);
	CT_RABoss_AddEvent("글루스", "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE", CT_RABoss_Gluth_EventHandler);
	CT_RABoss_AddEvent("글루스", "CHAT_MSG_ADDON", CT_RABoss_Gluth_EventHandler);
	CT_RABoss_AddEvent("글루스", "PLAYER_REGEN_DISABLED", CT_RABoss_Gluth_EventHandler);

	CT_RABoss_AddDropDownButton("글루스", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
	CT_RABoss_AddDropDownButton("글루스", { CT_RABOSS_GLUTH_FRENZY_ALERT, CT_RABOSS_GLUTH_FRENZY_ALERT_INFO }, "CT_RABoss_ModInfo", "frenzyalert", "CT_RABoss_SetInfo");
	CT_RABoss_AddDropDownButton("글루스", { CT_RABOSS_GLUTH_FEAR_ALERT, CT_RABOSS_GLUTH_FEAR_ALERT_INFO }, "CT_RABoss_ModInfo", "fearalert", "CT_RABoss_SetInfo");

	CT_RABoss_SetVar("글루스", "frenzyalert", 1);
	CT_RABoss_SetVar("글루스", "fearalert", 1);
end

function CT_RABoss_Gluth_Start()
	CT_RABoss_Announce(CT_RABOSS_GLUTH_ENGAGED, CT_RABoss_Mods["글루스"]["announce"]);
	CT_RABoss_PlaySound(3);
	CT_RABoss_Schedule("CT_RABoss_Gluth_EventHandler", 100, "decimatewarn");
	CT_RABoss_Mods["글루스"]["lastaction"] = time();
	CT_RABoss_Mods["글루스"]["engaged"] = true;

	if ( CT_RA_Level >= 1 and CT_RABoss_Mods["글루스"]["announce"] ) then
		CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_GLUTH_DECIMATESTRING, "105", "255*0*0"));
	end
end

function CT_RABoss_Gluth_EventHandler(event)
	if ( not CT_RABoss_Mods["글루스"] or not CT_RABoss_Mods["글루스"]["status"] or not CT_RABoss_Mods["글루스"].enabled ) then
		return;
	end

	if ( CT_RABoss_Mods["글루스"]["engaged"] and ( not CT_RABoss_Mods["글루스"]["lastaction"] or ( time() - CT_RABoss_Mods["글루스"]["lastaction"] ) > 60 ) ) then
		CT_RABoss_Mods["글루스"]["engaged"] = false;
	end

	if ( event == "CHAT_MSG_MONSTER_EMOTE" and arg2 == CT_RABOSS_GLUTH_BOSSNAME ) then
		if ( arg1 == CT_RABOSS_GLUTH_FRENZYSTRING and CT_RABoss_Mods["글루스"]["frenzyalert"] ) then
			CT_RABoss_Announce(CT_RABOSS_GLUTH_FRENZYWARNING, CT_RABoss_Mods["글루스"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_Mods["글루스"]["lastaction"] = time();
		end

	elseif ( event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE" or event == "CHAT_MSG_SPELL_CREATURE_VS_PARTY_DAMAGE" or event == "CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE" ) then
		if ( string.find(arg1, CT_RABOSS_GLUTH_DECIMATESTRING) and not CT_RABoss_Mods["글루스"]["decimated"] ) then
			CT_RABoss_Mods["글루스"]["decimated"] = true;
			CT_RABoss_Announce(CT_RABOSS_GLUTH_DECIMATEWARNING, CT_RABoss_Mods["글루스"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_Schedule("CT_RABoss_Gluth_EventHandler", 105, "decimatewarn");
			CT_RABoss_Schedule("CT_RABoss_Gluth_EventHandler", 5, "undecimate");
			CT_RABoss_Mods["글루스"]["lastaction"] = time();

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["글루스"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_GLUTH_DECIMATESTRING, "110", "255*0*0"));
			end
		end

	elseif ( event == "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE" or event == "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE" or event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE" ) then
		if ( string.find(arg1, CT_RABOSS_GLUTH_FEARSTRING) and CT_RABoss_Mods["글루스"]["fearalert"] and not CT_RABoss_Mods["글루스"]["feartrip"] ) then
			CT_RABoss_Mods["글루스"]["feartrip"] = true;
			CT_RABoss_Announce(CT_RABOSS_GLUTH_FEARWARNING, CT_RABoss_Mods["글루스"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_Schedule("CT_RABoss_Gluth_EventHandler", 15, "prefear");
			CT_RABoss_Mods["글루스"]["lastaction"] = time();

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["글루스"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "2", "20", CT_RABOSS_GLUTH_FEAR, "20", "0*0*255"));
			end
		end

	elseif ( event == "PLAYER_REGEN_DISABLED" and not CT_RABoss_Mods["글루스"]["engaged"] ) then
		if ( not CT_RABoss_Mods["글루스"]["engaged"] ) then
			CT_RABoss_Schedule("CT_RABoss_Gluth_EventHandler", 5, "engagecheck");
		end

	elseif ( event == "CHAT_MSG_ADDON" and arg1 == "CTRA" ) then
		if ( arg2 == "GLUTHENGSYNC" and not CT_RABoss_Mods["글루스"]["engaged"] ) then
			CT_RABoss_Gluth_Start();
		end

	elseif ( event == "engagecheck" and not CT_RABoss_Mods["글루스"]["engaged"] ) then
		if ( UnitName("target") == CT_RABOSS_GLUTH_BOSSNAME and UnitAffectingCombat("target") ) then
			CT_RABoss_Gluth_Start();
			CT_RA_SendMessage("GLUTHENGSYNC");

		elseif ( UnitName("playertarget") == CT_RABOSS_GLUTH_BOSSNAME and UnitAffectingCombat("playertarget") ) then
			CT_RABoss_Gluth_Start();
			CT_RA_SendMessage("GLUTHENGSYNC");
		else
			local i
			for i = 1, GetNumRaidMembers(), 1 do
				if ( UnitName("raid"..i.."target") == CT_RABOSS_GLUTH_BOSSNAME and UnitAffectingCombat("raid"..i.."target")) then
					CT_RABoss_Gluth_Start();
					CT_RA_SendMessage("GLUTHENGSYNC");
					break;
				end
			end
		end

	elseif ( event == "undecimate" ) then
		CT_RABoss_Mods["글루스"]["decimated"] = false;

	elseif ( event == "decimatewarn" ) then
		CT_RABoss_Announce(CT_RABOSS_GLUTH_DECIMATESOON, CT_RABoss_Mods["글루스"]["announce"]);
		CT_RABoss_PlaySound(2);

	elseif ( event == "prefear" ) then
		CT_RABoss_Mods["글루스"]["feartrip"] = false;
		CT_RABoss_Announce(CT_RABOSS_GLUTH_FEAR5SEC, CT_RABoss_Mods["글루스"]["announce"]);
		CT_RABoss_PlaySound(3);
	end
end

-- Thaddius - (23/08/2006) - Updated charge checking script.
function CT_RABoss_Thaddius_OnLoad()
	CT_RABoss_AddMod("타디우스", CT_RABOSS_THADDIUS_INFO, 1, CT_RABOSS_LOCATIONS_NAXXRAMAS);
	CT_RABoss_AddEvent("타디우스", "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE", CT_RABoss_Thaddius_EventHandler);
	CT_RABoss_AddEvent("타디우스", "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF", CT_RABoss_Thaddius_EventHandler);
	CT_RABoss_AddEvent("타디우스", "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS", CT_RABoss_Thaddius_EventHandler);
	CT_RABoss_AddEvent("타디우스", "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE", CT_RABoss_Thaddius_EventHandler);
	CT_RABoss_AddEvent("타디우스", "CHAT_MSG_MONSTER_YELL", CT_RABoss_Thaddius_EventHandler);

	CT_RABoss_AddDropDownButton("타디우스", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
	CT_RABoss_AddDropDownButton("타디우스", { CT_RABOSS_THADDIUS_SURGE_ALERT, CT_RABOSS_THADDIUS_SURGE_ALERT_INFO }, "CT_RABoss_ModInfo", "surgealert", "CT_RABoss_SetInfo");

	CT_RABoss_SetVar("타디우스", "surgealert", 1);
end

function CT_RABoss_Thaddius_EventHandler(event)
	if ( not CT_RABoss_Mods["타디우스"] or not CT_RABoss_Mods["타디우스"]["status"] or not CT_RABoss_Mods["타디우스"].enabled ) then
		return;
	end

	if ( event == "CHAT_MSG_MONSTER_YELL" ) then
		if ( arg1 == CT_RABOSS_THADDIUS_PHASE1_YELL1 or arg1 == CT_RABOSS_THADDIUS_PHASE1_YELL2 ) then
			if ( not CT_RABoss_Mods["타디우스"]["firstyell"] ) then
				CT_RABoss_Announce(CT_RABOSS_THADDIUS_PHASE1, CT_RABoss_Mods["타디우스"]["announce"]);
				CT_RABoss_PlaySound(3);
				CT_RABoss_Mods["타디우스"]["firstyell"] = true;
				CT_RABoss_Schedule("CT_RABoss_Thaddius_EventHandler", 5, "yellreset");
			end
		elseif ( arg1 == CT_RABOSS_THADDIUS_PHASE2_YELL1 or arg1 == CT_RABOSS_THADDIUS_PHASE2_YELL2 or arg1 == CT_RABOSS_THADDIUS_PHASE2_YELL3 ) then
			CT_RABoss_Announce(CT_RABOSS_THADDIUS_PHASE2, CT_RABoss_Mods["타디우스"]["announce"]);
			CT_RABoss_PlaySound(3);
			CT_RABoss_Schedule("CT_RABoss_Thaddius_EventHandler", 30, "enragetimer");
			CT_RABoss_Mods["타디우스"]["enrageleft"] = 4.5;
			CT_RABoss_Mods["타디우스"]["lastaction"] = time();

		elseif ( arg1 == CT_RABOSS_THADDIUS_DEAD ) then
			CT_RABoss_UnSchedule("CT_RABoss_Thaddius_EventHandler");
		end

	elseif ( event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS" ) then
		if ( arg1 == CT_RABOSS_THADDIUS_SURGESTRING and CT_RABoss_Mods["타디우스"]["surgealert"] ) then
			CT_RABoss_Announce(CT_RABOSS_THADDIUS_SURGE, CT_RABoss_Mods["타디우스"]["announce"]);
			CT_RABoss_PlaySound(2);
		end

	elseif ( event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE" or event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF" ) then
		if ( arg1 == CT_RABOSS_THADDIUS_POLARITYSTRING ) then
			CT_RABoss_Announce(CT_RABOSS_THADDIUS_POLARITYWARN, CT_RABoss_Mods["타디우스"]["announce"]);
			CT_RABoss_PlaySound(3);
			CT_RABoss_Mods["타디우스"]["lastaction"] = time();

		elseif ( arg1 == CT_RABOSS_THADDIUS_SHIFTSTRING ) then
			CT_RABoss_Announce(CT_RABOSS_THADDIUS_SHIFTWARN, CT_RABoss_Mods["타디우스"]["announce"]);
			CT_RABoss_PlaySound(1);
			CT_RABoss_Mods["타디우스"]["lastaction"] = time();
			CT_RABoss_Schedule("CT_RABoss_Thaddius_EventHandler", 0.5, "debuffcheck");

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["타디우스"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_MRTHADDIUS_POLARITY, "30", "255*0*0"));
			end
		end

	elseif ( event == "CHAT_MSG_MONSTER_EMOTE" and arg2 == CT_RABOSS_THADDIUS_BOSSNAME ) then
		if ( arg1 == CT_RABOSS_THADDIUS_BERSERKSTRING ) then
			CT_RABoss_Announce(CT_RABOSS_THADDIUS_BERSERKWARNING, CT_RABoss_Mods["타디우스"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_UnSchedule("CT_RABoss_Thaddius_EventHandler", "enragetimer");
			CT_RABoss_UnSchedule("CT_RABoss_Thaddius_EventHandler", "enrage15");
			CT_RABoss_UnSchedule("CT_RABoss_Thaddius_EventHandler", "enrage5");
			CT_RABoss_Mods["타디우스"]["lastaction"] = time();
		end

	elseif ( event == "enragetimer") then
		if ( not CT_RABoss_Mods["타디우스"]["lastaction"] or ( time() - CT_RABoss_Mods["타디우스"]["lastaction"] ) > 60 ) then
			return;
		end
		if ( CT_RABoss_Mods["타디우스"]["enrageleft"] == 0.5 ) then
			CT_RABoss_Schedule("CT_RABoss_Thaddius_EventHandler", 15, "enrage15");
			CT_RABoss_Schedule("CT_RABoss_Thaddius_EventHandler", 25, "enrage5");
			CT_RABoss_Announce(format(CT_RABOSS_THADDIUS_SECWARN, "30"), CT_RABoss_Mods["타디우스"]["announce"]);
			CT_RABoss_PlaySound(3);
		else
			if ( CT_RABoss_Mods["타디우스"]["enrageleft"] == 1 ) then
				CT_RABoss_Announce(CT_RABOSS_THADDIUS_1MINWARN, CT_RABoss_Mods["타디우스"]["announce"]);
			else
				CT_RABoss_Announce(format(CT_RABOSS_THADDIUS_WARN, CT_RABoss_Mods["타디우스"]["enrageleft"]), CT_RABoss_Mods["타디우스"]["announce"]);
			end

			CT_RABoss_Mods["타디우스"]["enrageleft"] = CT_RABoss_Mods["타디우스"]["enrageleft"]-0.5;
			CT_RABoss_Schedule("CT_RABoss_Thaddius_EventHandler", 30, "enragetimer");
			CT_RABoss_PlaySound(3);
		end

	elseif ( event == "debuffcheck" ) then
		local i = 1
		local charge = nil;
		while UnitDebuff("player", i) do
			local t = UnitDebuff("player",i);
			if ( t == CT_RABOSS_THADDIUS_POSITIVE or t == CT_RABOSS_THADDIUS_NEGATIVE ) then
				charge = t;
			end
		end
	
		if ( charge == nil ) then
			return;
		elseif ( charge ) then
			if ( charge == oldcharge ) then
				CT_RABoss_Announce(CT_RABOSS_THADDIUS_NOCHANGEWARN);
			elseif ( charge == CT_RABOSS_THADDIUS_POSITIVE ) then
				CT_RABoss_Announce(CT_RABOSS_THADDIUS_POSITIVEWARN);
			elseif ( charge == CT_RABOSS_THADDIUS_NEGATIVE ) then
				CT_RABoss_Announce(CT_RABOSS_THADDIUS_NEGATIVEWARN);
			end
		end
		local oldcharge = charge;

	elseif ( event == "yellreset" ) then
		CT_RABoss_Mods["타디우스"]["firstyell"] = false;

	elseif ( event == "enrage15" ) then
		CT_RABoss_Announce(format(CT_RABOSS_THADDIUS_SECWARN, "15"), CT_RABoss_Mods["타디우스"]["announce"]);
		CT_RABoss_PlaySound(3);

	elseif ( event == "enrage5" ) then
		CT_RABoss_Announce(format(CT_RABOSS_THADDIUS_SECWARN, "5"), CT_RABoss_Mods["타디우스"]["announce"]);
		CT_RABoss_PlaySound(3);
	end
end